/*==========================================================================

  Title   : DQTOOLW.C
  Purpose : This program is the test driver for the Data Queue APIs.

==========================================================================*/

#include <windows.h>   /* required for windows programs    */
#include <memory.h>    /* required for C memory routines   */
#include <string.h>    /* required for C string routines   */
#include <stdlib.h>    /* required for standard C routines */
#include <stdio.h>     /* required for C I/O routines      */
#include <ctype.h>     /* required for conversion routines */
#include <time.h>      /* required for C time routines     */
#include <dde.h>       /* required for DDE calls           */
#include <ehndqw.h>    /* required for data queue APIs     */
#include "dqtoolw.h"   /* specific to this program         */

/*========================================================================
   Global Variables
=========================================================================*/

int   nNegativeFlag;
int   Infp;                   /* input file identifier */
long  InFileLen;              /* length of input file */
HANDLE hInFileBuf;            /* handle to input file buffer */
char far *InFileBuf;          /* pointer to input file buffer */
char far *InFilePos;          /* pointer to current position in input file */
long Char_Count;              /* counter for input characters */

int   Outfp;                  /* ouput file identifier */
LONG  OutFileLen;             /* length of output file */
HANDLE hOutFileBuf;           /* handle to output file buffer */
char far *OutFileBuf;         /* pointer to output file buffer */
char delimiter;               /* test file field delimiter */

BOOL show_sendid;      /* variables used when displaying parameters */
BOOL show_seq;
BOOL show_force;
BOOL show_auth;
BOOL show_keylen;
BOOL show_mode;
BOOL show_wait;
BOOL show_max;
BOOL show_len;
BOOL show_sys;
BOOL show_dq;
BOOL show_key;
BOOL show_text;
BOOL show_order;

HANDLE hInst;              /* instance handle */
HWND hWnd1;                /* window handle */
WORD wType;                /* the type of menu selection */
BOOL *Trans;               /* used when translating text to int */
BOOL Translated;           /* same as above */
char LongData[21];         /* Used for converting text to long int */
BOOL VIEW_BUF = 1;         /* flag for displaying buffer */

int nRC;

HANDLE hBuf;               /* handle to buffer memory */
HANDLE hBuf1;              /* handle to buffer memory */
HANDLE hBuf2;              /* handle to buffer memory */
HANDLE hBuf3;              /* handle to buffer memory */
HANDLE hBuf4;              /* handle to buffer memory */
HANDLE hBuf5;              /* handle to buffer memory */

char far *Buf;             /* far pointer to buffer */
char far *v;               /* utility pointer used to manipulate above */

WORD buf_size  = 512;      /* size of buffer allocated */
WORD buf_size1 = 512;      /* size of buffer allocated */
WORD buf_size2 = 512;      /* size of buffer allocated */
WORD buf_size3 = 512;      /* size of buffer allocated */
WORD buf_size4 = 512;      /* size of buffer allocated */
WORD buf_size5 = 512;      /* size of buffer allocated */
WORD wCurrentBuf;          /* Currently active set of buffers. */

int DQ_RC;                 /* API return code */
WORD NUMLINES = 20;        /* Number of lines on display */

char     DQ_Name[41];      /* Data Queue Nam */
char     Tpc_Name[61];     /* Topic Name */
unsigned long Mode;        /* Conversion mode */
int Sequence;              /* Queueing sequence */
int Force;                 /* Force to aux. storage */
int Authority;             /* Host Authority */
int SendId;                /* Store/retrieve sender id */
int FuncLevel;             /* Functional Level */
char     Description[100]; /* Queue description */
int KeyLength;             /* Length of key */
unsigned long MaxLength;   /* maximum length of message */
unsigned long BufLength;   /* length of message sent */
unsigned long RcvBufLength;/* length of buffer to receive into */

unsigned long RecLength;       /* length of message returned */
unsigned long RecLength1 = 0;  /* length of message returned */
unsigned long RecLength2 = 0;  /* length of message returned */
unsigned long RecLength3 = 0;  /* length of message returned */
unsigned long RecLength4 = 0;  /* length of message returned */
unsigned long RecLength5 = 0;  /* length of message returned */
long far *lplRecLength;        /* Pointer to the length buffer */

char     Key_Name[300];    /* name of key */

char      RecKey_Name[300];  /* name of key returned */
char      RecKey_Name1[300]; /* name of key returned */
char      RecKey_Name2[300]; /* name of key returned */
char      RecKey_Name3[300]; /* name of key returned */
char      RecKey_Name4[300]; /* name of key returned */
char      RecKey_Name5[300]; /* name of key returned */
char far *lpszRecKey_Name;  /* Pointer to receive key */

LONG WaitTime;             /* wait time */
char     Search_Order[3];  /* search order */
char msgd[152];            /* message data */
LPSTR MsgData = msgd;      /* pointer to message data */
int MsgLength;             /* length of message data */

char      SenderInfo[36];   /* jobname/username/jobnumber/userprofile. */
char      SenderInfo1[36];  /* jobname/username/jobnumber/userprofile. */
char      SenderInfo2[36];  /* jobname/username/jobnumber/userprofile. */
char      SenderInfo3[36];  /* jobname/username/jobnumber/userprofile. */
char      SenderInfo4[36];  /* jobname/username/jobnumber/userprofile. */
char      SenderInfo5[36];  /* jobname/username/jobnumber/userprofile. */
char far *lpachSenderInfo; /* Pointer to sender ID info buffer        */

char     JobName[11];      /* job name */
char     UserName[11];     /* user name */
char     JobNum[7];        /* job number */
char     UserProfile[11];  /* user profile */
char File_Name[128];       /* file name */
char Path_Name[128];       /* path name */
char Open_Name[128];       /* open file name */
char Output_File[128];     /* output file name */
char Def_Path[128] = "";   /* default path */
char Def_Spec[13] = "*.*"; /* default specifications */
char str[255];             /* string buffer */
char Variation[16];        /* variation name */
char comment[72];          /* comment */
LPSTR lpDQ_Name;           /* long pointers used when calling */
LPSTR lpSys_Name;          /* API routines */
LPSTR lpDesc;              /*  "  */
LPSTR lpKey_Name;          /*  "  */
LPSTR lpSearchO;           /*  "  */
LPSTR lpJobName;           /*  "  */
LPSTR lpUserName;          /*  "  */
LPSTR lpJobNum;            /*  "  */
LPSTR lpUserProfile;       /*  "  */
LPSTR lpRecKey_Name;       /*  "  */
BOOL Send_Null_Win;        /* Flag for send Null window handle */
BOOL Repeat_Fill;          /* Flag for filling buffer by repeating chars */
BOOL Input_Fill;           /* Flag for filling buffer from input file */
BOOL Manual_Fill;          /* Flag for filling buffer from keyboard */

unsigned long current_mode = 0L;  /* flag for current mode */
OFSTRUCT InOfStruct;       /* input openfile structure */
OFSTRUCT OutOfStruct;      /* ouput openfile structure */

char     outdata[1000];                /* output data */
char     tmpdata[300];
char outputdata[200];
static char OutputString[4000];
static char filedata[4000];
LPSTR lpfiledata = filedata;

clock_t cur_time;       /* variables used for telling time */
struct tm *z;
char wdata[80];
char *w = wdata;

short cxChar, cxCaps, cyChar;   /* text size variables */
short cxClient, cyClient;       /* window size variables */
short nHscrollPos, nHscrollMax, nMaxWidth;   /* scrolling vars */
short nVscrollPos, nVscrollMax;     /* same */

char     Sys_Name[21];     /* System Name */
char     App_Name[61];     /* Application Name */
char     Net_Name[301];    /* Network Path Name */
char     Cmd_Str[1024];    /* String of commands to execute */
char     szItem[301];      /* returned atom */
char     szData[32000];    /* Data for Poke */
int      nItem = 301;      /* length of the atom returned */
ATOM     aApp;             /* Atom to hold application name */
ATOM     aTop;             /* Atom to hold topic name */
ATOM     aItem;            /* Item being sent with DDE verb */
BOOL     fDoingInit = FALSE; /* flag to indicate an init is happening */
BOOL     fDoingQuery= FALSE; /* flag to indicate an queryis happening */
BOOL     fRelease;         /* flag to indicate to release poke mem */
BOOL     fStillLocked = FALSE; /* flag to tell us to relase memory */
WORD     cfClipBd;         /* Clipboard Format */
WORD     Ack_Req;          /* Acknowledgement requested indicator */
DDEACK   wStatus;          /* The status WORD that is returned in ACK*/
HANDLE   hWndServer = 0xFFFF; /* handle for the DDE server */
HANDLE   hDdeAdvise;       /* handle for the DDEADVISE structure */
HANDLE   hDdeData;         /* handle for the DDEDATA structure */
HANDLE   hCommands;        /* handle for the DDEEXECUTE commands */
HANDLE   hData;            /* handle for the DDEPOKE structure */
DDEADVISE far * lpDdeAdvise; /*pointer to the ADVISE structure */
DDEDATA far * lpDdeData;     /*pointer to the DDEDATA structure */
DDEPOKE far * lpData;        /*pointer to the DDEPOKE structure */
char far * lpCommands;       /*pointer to the DDEEXECUTE commands */

typedef struct {
   long                 lMaxLength;
   int                  nSequence;
   int                  nForce;
   BOOL                 bSenderID;
   char                 szText[51];
   int                  nKeyLen;
               }
   QUERYSTRUCT;

QUERYSTRUCT far *query;             /* Query structure parameter     */

/*========================================================================
   WinMain: Registers Window, creates Window and processes message loop.
=========================================================================*/
int PASCAL WinMain ( HANDLE hInstance,       /* current program instance */
                     HANDLE hPrevInstance,   /* previous pgm instance */
                     LPSTR lpszCmdLine,      /* command line info */
                     int nCmdShow )          /* show window? */

{
  WNDCLASS rClass;               /* window class structure */
  MSG msg;                       /* message */

  hInst = hInstance;             /* save instance in static var */
  if ( !hPrevInstance )          /* check if other instances exist */
   {
/*============================================================================
      Register Class for Window
*/

    rClass.lpszClassName = "DQtoolClass";           /* class name */
    rClass.hInstance     = hInstance;               /* class owner */
    rClass.lpfnWndProc   = WndProc;             /* proc. to receive messages */
    rClass.hCursor       = LoadCursor( NULL, IDC_ARROW );    /* arrow cursor */
    rClass.hIcon         = LoadIcon( NULL,IDI_APPLICATION ); /* generic icon */
    rClass.lpszMenuName  = "DQMENU";            /* name of menu in .RC file  */
    rClass.hbrBackground = COLOR_WINDOW+1;          /* window color */
    rClass.style         = CS_HREDRAW|CS_VREDRAW;   /* resizing info */
    rClass.cbClsExtra    = 0;                       /* no class extra data */
    rClass.cbWndExtra    = 0;                       /* no window extra data */

     RegisterClass( &rClass );                  /* register the window */
   }

  hWnd1 = CreateWindow( "DQtoolClass",          /* window class */
                        "DQtool",               /* window title */
                        WS_OVERLAPPEDWINDOW|WS_VSCROLL|WS_HSCROLL, /* style */
                        0,                      /* horizontal pos */
                        15,                     /* vertical pos */
                        645,                    /* width */
                        318,                    /* height */
                        NULL,                   /* no parent */
                        NULL,                   /* use class menu */
                        hInstance,              /* window owner */
                        NULL );                 /* no pointer */
  ShowWindow( hWnd1, nCmdShow );

  while ( GetMessage( &msg, NULL, 0, 0))     /*message loop - receives msg */
   {
     TranslateMessage(&msg);        /* translate virtual key codes */
     DispatchMessage(&msg);         /* dispatches message to window */
   }
  return  msg.wParam;             /* returns value form quit message */
}

/*========================================================================
   WndProc: processes the messages sent to window
*/
long FAR PASCAL WndProc( HWND hWnd,       /* handle to window */
                         WORD wMsgID,     /* ID number of message */
                         WORD wParam,     /* 16-bit parameter */
                         LONG lParam )    /* 32-bit parameter */
{
  HDC hdc;                           /* device context handle */
  PAINTSTRUCT ps;                    /* paint structure */
  TEXTMETRIC tm;                     /* text metric structure */
  static FARPROC lpfnFileDlgProc;    /* pointer to file dialog proc. */
  static FARPROC lpfnParmDlgProc;    /* pointer to API param dialog proc */
  int ReturnCode;                    /* API call return code */
  int NotCanceled;                   /* Flag for canceled dialog box */
  short i,j,y,x;                     /* counters and window cordinates */
  WORD buf_count,line_num;           /* used for displaying buffer */
  short nVscrollInc,nHscrollInc;     /* Vert. and Horiz. Scroll increments */
  int xpos;                          /* Used for column position on view buf */
  HFONT hFont, hOldFont ;            /* handles for font changes */
  HCURSOR hCursor,hOldCursor;        /* handles for cursor changes */
  short PaintBeg,PaintEnd;           /* marks part of buffer to view */

  switch (wMsgID)
   {
    case  WM_CREATE :    /* MESSAGE : create window */
        /* get pointers to dialog procedures */
      lpfnParmDlgProc = MakeProcInstance( ParmDlgProc, hInst );
      lpfnFileDlgProc = MakeProcInstance(FileDlgProc, hInst);

        /* get device context for using text metric */
      hdc = GetDC( hWnd );
      GetTextMetrics( hdc, &tm );
      cxChar = tm.tmAveCharWidth;                  /* set avg width of char */
      cxCaps = (tm.tmPitchAndFamily&1 ? 3 : 2) * cxChar / 2;   /* max width */
      cyChar = tm.tmHeight + tm.tmExternalLeading;    /* max height of char */

        /* get fixed font for buffer painting and store old one */
      hFont = GetStockObject( ANSI_FIXED_FONT );
      hOldFont = SelectObject( hdc, hFont );
      ReleaseDC( hWnd, hdc );
      nMaxWidth = 80 * cxChar;                    /* width of window output */

      /* allocate buffers, Setup receive buffers for Sender ID info */
      /* Key info and length values                                 */
      alloc_bufs();
      return 0;

     case  WM_SIZE :               /* MESSAGE : resize window */
         /* get size of current window */
       cyClient = HIWORD(lParam);
       cxClient = LOWORD(lParam);

         /* set number of lines of output, maximum scroll and thumb position */
       NUMLINES = buf_size/16;
       nVscrollMax = max(0, NUMLINES+5-cyClient/cyChar);
       nVscrollPos = min(nVscrollPos, nVscrollMax);
         /* set vertical scroll range and set vertical thumb pos */
       SetScrollRange(hWnd, SB_VERT, 0, nVscrollMax, FALSE );
       SetScrollPos(hWnd, SB_VERT, nVscrollPos, TRUE );

         /* do the same for horizontal scroll bar */
       nHscrollMax = max(0, 2+(nMaxWidth-cxClient)/cxChar);
       nHscrollPos = min(nHscrollPos, nHscrollMax);
       SetScrollRange(hWnd, SB_HORZ, 0, nHscrollMax, FALSE );
       SetScrollPos(hWnd, SB_HORZ, nHscrollPos, TRUE );
       return 0;


     case  WM_VSCROLL :         /* MESSAGE : mouse did vertical scroll */
       switch (wParam)
         {                      /* adjust vertical increment depending */
           case  SB_TOP :                            /* on user action */
             nVscrollInc = -nVscrollPos;
             break;
           case  SB_BOTTOM :
             nVscrollInc = nVscrollMax-nVscrollPos;
             break;
           case  SB_LINEUP :
             nVscrollInc = -1;
             break;
           case  SB_LINEDOWN :
             nVscrollInc = 1;
             break;
           case  SB_PAGEUP :
             nVscrollInc = min(-1, -cyClient/cyChar);
             break;
           case  SB_PAGEDOWN :
             nVscrollInc = max(1, cyClient/cyChar);
             break;
           case  SB_THUMBPOSITION :
             nVscrollInc = LOWORD(lParam)-nVscrollPos;
             break;
           default  :
             nVscrollInc = 0;
         }
           /* check increment and if valid scroll window */
       if (nVscrollInc = max( -nVscrollPos,
                              min( nVscrollInc,
                                   nVscrollMax-nVscrollPos)))
         {
           nVscrollPos += nVscrollInc;
           ScrollWindow( hWnd, 0, -cyChar *nVscrollInc, NULL, NULL );
           SetScrollPos( hWnd, SB_VERT, nVscrollPos, TRUE);
           UpdateWindow( hWnd );
         }
       return 0;


     case  WM_HSCROLL :           /* MESSAGE : mouse did horizontal scroll */
       switch (wParam)
         {                        /* adjust horizontal increment depending */
           case  SB_LINEUP :                            /* on user action */
             nHscrollInc = -1;
             break;
           case  SB_LINEDOWN :
             nHscrollInc = 1;
             break;
           case  SB_PAGEUP :
             nHscrollInc = -8;
             break;
           case  SB_PAGEDOWN :
             nHscrollInc = 8;
             break;
           case  SB_THUMBPOSITION :
             nHscrollInc = LOWORD(lParam)-nHscrollPos;
             break;
           default  :
             nHscrollInc = 0;
         }
           /* check increment and if valid scroll window */
       if (nHscrollInc = max( -nHscrollPos,
                              min( nHscrollInc,
                                   nHscrollMax-nHscrollPos )))
         {
           nHscrollPos += nHscrollInc;
           ScrollWindow( hWnd, -cxChar *nHscrollInc, 0, NULL, NULL );
           SetScrollPos( hWnd, SB_HORZ, nHscrollPos, TRUE );
           UpdateWindow(hWnd);
         }
       return 0;


     case  WM_KEYDOWN :             /* MESSAGE : keyboard did scroll */
       switch (wParam)              /* send appropriate scroll message */
         {                          /* two the above case statements */
           case  VK_HOME :
             SendMessage(hWnd, WM_VSCROLL, SB_TOP, 0L);
             break;
           case  VK_END :
             SendMessage(hWnd, WM_VSCROLL, SB_BOTTOM, 0L);
             break;
           case  VK_PRIOR :
             SendMessage(hWnd, WM_VSCROLL, SB_PAGEUP, 0L);
             break;
           case  VK_NEXT :
             SendMessage(hWnd, WM_VSCROLL, SB_PAGEDOWN, 0L);
             break;
           case  VK_UP :
             SendMessage(hWnd, WM_VSCROLL, SB_LINEUP, 0L);
             break;
           case  VK_DOWN :
             SendMessage(hWnd, WM_VSCROLL, SB_LINEDOWN, 0L);
             break;
           case  VK_LEFT :
             SendMessage(hWnd, WM_HSCROLL, SB_PAGEUP, 0L);
             break;
           case  VK_RIGHT :
             SendMessage(hWnd, WM_HSCROLL, SB_PAGEDOWN, 0L);
             break;
         }
       return 0;


     case  WM_PAINT :                       /* MESSAGE : paint window */
          /* set cursor to hour glass */
       hCursor = LoadCursor( NULL, IDC_WAIT );
       hOldCursor = SetCursor( hCursor );
       ShowCursor( 1 );
          /* get device context handle to paint struct */
       hdc = BeginPaint( hWnd, &ps );

          /* select fixed font for buffer painting */
       hFont = GetStockObject(ANSI_FIXED_FONT);
       hOldFont = SelectObject( hdc, hFont );

          /* these will only paint the buffer that is seen in window */
       PaintBeg = max(0, nVscrollPos+ps.rcPaint.top/cyChar);
       PaintEnd = min(NUMLINES, nVscrollPos+ps.rcPaint.bottom/cyChar);

          /* if the view buffer option is selected */
       if (VIEW_BUF)
         {
              /* find position in buffer to paint */
           line_num = PaintBeg;
           v = Buf+line_num *16;

              /* output buffer size */
           wsprintf(OutputString, "Buffer Size : %u ", buf_size);
           x = cxChar *(1-nHscrollPos);
           y = cyChar *(1-nVscrollPos+line_num);
           TextOut(hdc, x, y, OutputString, lstrlen(OutputString));

              /* output current conversion mode on same line */
           if (current_mode)
              lstrcpy(OutputString, "Conversion Mode : ON");
           else
              lstrcpy(OutputString, "Conversion Mode : OFF");
           x = cxChar *(1-nHscrollPos+50);
           TextOut(hdc, x, y, OutputString, lstrlen(OutputString));


           /* Display the string indicating what set of buffers is */
           /* currently active.                                    */
           wsprintf(OutputString, "Current Buffer: %u ", wCurrentBuf);
           x = cxChar *(1-nHscrollPos);
           y = cyChar *(1-nVscrollPos+line_num+1);
           TextOut(hdc, x, y, OutputString, lstrlen(OutputString));


              /* output column headings */
           lstrcpy(OutputString,
"       0 1   2 3   4 5   6 7   8 9   A B   C D   E F        ASCII     ");
           x = cxChar * (1-nHscrollPos);
           y = cyChar * (1-nVscrollPos+line_num+2);
           TextOut(hdc, x, y, OutputString, lstrlen(OutputString));

              /* start loop to dump buffer, buf_count makes sure we don't */
              /* read past buffer bounds  */
           buf_count = 0;
           while (( buf_count < ((NUMLINES-PaintBeg) * 16)) &&
                  ( line_num <  PaintEnd))
             {
                  /* output the line number in hex */
               x = cxChar *(1-nHscrollPos);
               y = cyChar *(1-nVscrollPos+line_num+3);
               wsprintf(OutputString, "%5X", line_num);
               TextOut(hdc, x, y, OutputString, lstrlen(OutputString));

                  /* output a line of the buffer once in hex and once  */
                  /* in ascii the xpos is used to space the columns properly */
               xpos = 6;
               for (j = 0; j < 16; j++)        /* only 16 chars per line */
                 {    /* format as hex */
                   wsprintf(OutputString, "%2X",  *v);
                   x = cxChar *(1-nHscrollPos+xpos);
                   TextOut(hdc, x, y, OutputString, lstrlen(OutputString));
                      /* format as ascii */
                   wsprintf(OutputString, "%1c",  *v);
                   x = cxChar *(1-nHscrollPos+58+j);
                   TextOut(hdc, x, y, OutputString, lstrlen(OutputString));
                   v++;                  /* increment buffer pointer */
                   buf_count++;          /* increment buffer count */
                   if ((xpos-2)%6 == 0)  /* see if we should space over */
                      xpos += 2;         /* to next column */
                   xpos += 2;
                 }
               line_num++;     /* increment line number */
             }
         }
       ShowCursor(0);            /* change cursor back to arrow */
       hOldCursor = SetCursor(hOldCursor);
       EndPaint(hWnd, &ps);     /* release painting device context */
       return 0;


     case  WM_COMMAND :           /* MESSAGE : menu option selected */
       switch (wParam)
        {
          case  IDM_CREATE_DQ :  /* Create data queue api seleceted */
            wType = 1;           /* set type of command...used everywhere */
            NotCanceled = DialogBox(hInst, "DLG_CREATE", hWnd, lpfnParmDlgProc);
            if (NotCanceled)     /* call create dialog box and if user */
              {  DQ_RC = Run_Command(wType);   /* selected okay run command */
                 Show_Results();               /* display return code */
              }
            break;

          case  IDM_CREATE_DK :  /* Create keyed dq api selected */
            wType = 2;           /* set type of command...used everywhere */
            NotCanceled = DialogBox(hInst, "DLG_CREATE", hWnd, lpfnParmDlgProc);
            if (NotCanceled)    /* call create dialog box and if user */
              {  DQ_RC = Run_Command(wType);   /* selected okay run cmd */
                 Show_Results();               /* display return code */
              }
            break;

          case  IDM_CLEAR :    /* Clear data queue api selected */
            wType = 3;         /* set type to command...used below */
            NotCanceled = DialogBox(hInst,"DLG_DQSYS", hWnd, lpfnParmDlgProc);
            if (NotCanceled)   /* call the dq/sys dialog box and if user */
              {  DQ_RC = Run_Command(wType);  /* selected okay run command */
                 Show_Results();              /* display return code */
              }
            break;

          case  IDM_DELETE :  /* delete data queue api selected */
            wType = 4;        /* set api type */
            NotCanceled = DialogBox(hInst, "DLG_DQSYS", hWnd, lpfnParmDlgProc);
            if (NotCanceled)  /* call dq/sys dialog box and if user */
              {  DQ_RC = Run_Command(wType);   /* selected okay run command */
                 Show_Results();       /* display return code */
              }
            break;

          case  IDM_SEND_DQ :  /* send data queue api selected */
            wType = 5;         /* set api type */
            NotCanceled = DialogBox(hInst, "DLG_SEND", hWnd, lpfnParmDlgProc);
            if (NotCanceled)   /* call the send dialog box and if user */
              {  DQ_RC = Run_Command(wType);   /*selected okay run command */
                 Show_Results();       /* display the return code */
              }
            break;

          case  IDM_SEND_DK :   /* send keyed api selected */
            wType = 6;          /* set api type */
            NotCanceled = DialogBox(hInst, "DLG_SEND", hWnd, lpfnParmDlgProc);
            if (NotCanceled)    /* call the send dialog box and if user */
              {  DQ_RC = Run_Command(wType);   /*selected okay run command */
                 Show_Results();          /* display return code */
              }
            break;

     /* NOTE from here on out since most of this is repetition */
     /* comments will only reflect things that are different   */

          case  IDM_PUT_DQ :   /* put data queue api command selected */
            wType = 7;
            NotCanceled = DialogBox(hInst, "DLG_SEND", hWnd, lpfnParmDlgProc);
            if (NotCanceled)                    /* call send dialog box */
              {  DQ_RC = Run_Command(wType);
                 Show_Results();
              }
            break;

          case  IDM_PUT_DK :  /* put keyed api selected */
            wType = 8;
            NotCanceled = DialogBox(hInst, "DLG_SEND", hWnd, lpfnParmDlgProc);
            if (NotCanceled)   /* call send dialog box */
              {  DQ_RC = Run_Command(wType);
                 Show_Results();
              }
            break;

          case  IDM_RECEIVE_DQ :  /* receive data queue api selected */
            wType = 9;
            NotCanceled = DialogBox(hInst,"DLG_RECEIVE",hWnd, lpfnParmDlgProc);
            if (NotCanceled)     /* call receive dialog box */
              {  DQ_RC = Run_Command(wType);
                 Show_Results();
              }
            break;

          case  IDM_RECEIVE_DK :   /* receive keyed dq api selected */
            wType = 10;
            NotCanceled = DialogBox(hInst,"DLG_RECKEY", hWnd, lpfnParmDlgProc);
            if (NotCanceled)       /* call receive keyed dialog box */
              {  DQ_RC = Run_Command(wType);
                 Show_Results();
              }
            break;

          case  IDM_RECEIVE_IM :  /* receive request api selected */
            wType = 11;
            NotCanceled = DialogBox(hInst,"DLG_RECEIVE",hWnd, lpfnParmDlgProc);
            if (NotCanceled)      /* use the receive dialog box */
              {  DQ_RC = Run_Command(wType);
                 Show_Results();
              }
            break;

          case  IDM_RECEIVE_IK :  /* receive request keyed api selected */
            wType = 12;
            NotCanceled = DialogBox(hInst,"DLG_RECKEY",hWnd, lpfnParmDlgProc);
            if (NotCanceled)     /* use the receive keyed dialog box */
              {  DQ_RC = Run_Command(wType);
                 Show_Results();
              }
            break;

          case  IDM_RECEIVE_PR :  /* receive data api selected */
            wType = 13;
            NotCanceled = DialogBox(hInst,"DLG_DQSYS", hWnd, lpfnParmDlgProc);
            if (NotCanceled)     /* use the dq/sys dialog box */
              {  DQ_RC = Run_Command(wType);
                 Show_Results();
              }
            break;

          case  IDM_RECEIVE_PV :  /* receive data keyed api selected */
            wType = 14;
            NotCanceled = DialogBox(hInst,"DLG_DQPREV", hWnd,lpfnParmDlgProc);
            if (NotCanceled)        /* use the prev keyed dialog box */
              {  DQ_RC = Run_Command(wType);
                 Show_Results();
              }
            break;

          case  IDM_CANCEL_RQ :  /* receive data api selected */
            wType = 23;
            NotCanceled = DialogBox(hInst,"DLG_DQSYS", hWnd, lpfnParmDlgProc);
            if (NotCanceled)     /* use the dq/sys dialog box */
              {  DQ_RC = Run_Command(wType);
                 Show_Results();
              }
            break;

          case  IDM_CANCEL_RK :  /* receive data keyed api selected */
            wType = 24;
            NotCanceled = DialogBox(hInst,"DLG_DQPREV", hWnd,lpfnParmDlgProc);
            if (NotCanceled)        /* use the prev keyed dialog box */
              {  DQ_RC = Run_Command(wType);
                 Show_Results();
              }
            break;

          case  IDM_QUERY :  /* queury data queue api selected */
            wType = 15;
            NotCanceled = DialogBox(hInst,"DLG_DQSYS", hWnd, lpfnParmDlgProc);
            if (NotCanceled)    /* use the dq/sys dialog box */
              {  DQ_RC = Run_Command(wType);
                 Show_Results();
              }
            break;

          case  IDM_SET_MODE :  /* set conversion mode api selected */
            wType = 16;
            NotCanceled = DialogBox(hInst, "DLG_MODE", hWnd, lpfnParmDlgProc);
            if (NotCanceled)          /* use mode dialog box */
              {  DQ_RC = Run_Command(wType);     /* run command */
                 if (DQ_RC == 0)                /* if successfult */
                       current_mode = Mode;    /* set the current mode */
                 Show_Results();              /* display return code */
              }
            break;

          case  IDM_GET_MSG :    /* get message api selected */
            wType = 17;
            NotCanceled = DialogBox(hInst,"DLG_DQSYS", hWnd, lpfnParmDlgProc);
            if (NotCanceled)      /* use the dq/sys dialog box */
              {  DQ_RC = Run_Command(wType);
                 Show_Results();
              }
            break;

          case  IDM_STOP :   /* stop data queues api selected */
            wType = 18;
            NotCanceled = DialogBox(hInst,"DLG_DQSYS", hWnd, lpfnParmDlgProc);
            if (NotCanceled)         /* use the dq/sys dialog box */
               {  DQ_RC = Run_Command(wType);
                  Show_Results();
               }
             break;

           case  IDM_ADJUST : /* the adjust buffer size menu option selected */
             wType = 19;
             NotCanceled = DialogBox(hInst,"DLG_ADJUST",hWnd, lpfnParmDlgProc);
             if (NotCanceled)      /* use adjust buffer dialog box */
               adjust_buf();       /* call to adjust buffer function */
             break;

           case  IDM_VIEW :  /* the view buffer menu option was selected */
             VIEW_BUF = 1;   /* set view flag on */
             break;

           case  IDM_HIDE :  /* the hide buffer menu option was selected */
             VIEW_BUF = 0;   /* set view flag off */
             break;

           case  IDM_FLUSH :  /* the flush buffer menu option was selected */
             flush_buf();     /* call the flush buffer procedure */
             break;

           case  IDM_SWITCH : /* switch the current set of buffers to the */
             switch_buf();    /* next set                                 */
             VIEW_BUF = 1;
             break;

           case  IDM_EXECUTE :  /* the execute batch api file menu option */
             wType = 20;        /* was selected */
             NotCanceled = DialogBox(hInst,"EXECUTE",hWnd,lpfnFileDlgProc);
             if (NotCanceled)      /* use the execute dialog box */
                Execute_Batch();   /* call execute batch file procedure */
             break;

           case  IDM_GETVAR :  /* the get variation menu option was selected */
             wType = 21;
             NotCanceled = DialogBox(hInst,"GET", hWnd, lpfnFileDlgProc);
             if (NotCanceled)    /* use the get variation dialog box */
                Get_Var();       /* call get variation procedure */
             break;

           case  IDM_INIT   :  /* Isssue a DDE Initialize */
             wType = 26;
             NotCanceled = DialogBox(hInst,
                                     "DLG_INIT",
                                     hWnd,
                                     lpfnParmDlgProc);
            if (NotCanceled)      /* use the receive dialog box */
              {  DQ_RC = Run_Command(wType);
              }
             break;

           case  IDM_ADVISE :  /* Isssue a DDE Advise */
             wType = 27;
             NotCanceled = DialogBox(hInst,
                                     "DLG_ADVISE",
                                     hWnd,
                                     lpfnParmDlgProc);
            if (NotCanceled)      /* use the receive dialog box */
              {  DQ_RC = Run_Command(wType);
              }
             break;

           case  IDM_UNADVISE : /* Issue a DDE Unadvise */
             wType = 28;
             NotCanceled = DialogBox(hInst,
                                     "DLG_UNADVISE",
                                     hWnd,
                                     lpfnParmDlgProc);
            if (NotCanceled)      /* use the receive dialog box */
              {  DQ_RC = Run_Command(wType);
              }
             break;

           case  IDM_EXE :  /* Isssue a DDE Execute */
             wType = 29;
             NotCanceled = DialogBox(hInst,
                                     "DLG_EXE",
                                     hWnd,
                                     lpfnParmDlgProc);
            if (NotCanceled)      /* use the receive dialog box */
              {  DQ_RC = Run_Command(wType);
              }
             break;

           case  IDM_ACK :  /* Isssue a DDE Acknowledge */
             wType = 30;
             NotCanceled = DialogBox(hInst,
                                     "DLG_ACK",
                                     hWnd,
                                     lpfnParmDlgProc);
            if (NotCanceled)      /* use the receive dialog box */
              {  DQ_RC = Run_Command(wType);
              }
             break;

           case  IDM_REQ :  /* Isssue a DDE Request */
             wType = 31;
             NotCanceled = DialogBox(hInst,
                                     "DLG_REQ",
                                     hWnd,
                                     lpfnParmDlgProc);
            if (NotCanceled)      /* use the receive dialog box */
              {  DQ_RC = Run_Command(wType);
              }
             break;

           case  IDM_POKE :  /* Isssue a DDE Poke */
             wType = 32;
             NotCanceled = DialogBox(hInst,
                                     "DLG_POKE",
                                     hWnd,
                                     lpfnParmDlgProc);
            if (NotCanceled)      /* use the receive dialog box */
              {  DQ_RC = Run_Command(wType);
              }
             break;

           case  IDM_TERMINATE : /* Issue a DDE Terminate */
             wType = 33;
             DQ_RC = Run_Command(wType);
             break;

           case  IDM_EXIT :     /* the exit menu option was selected */
             DestroyWindow(hWnd);    /* send destroy message to windows */
             break;

           case  IDM_FUNC_LVL :
             wType = 22;
             DQ_RC = Run_Command(wType);
             Show_Results();
             break;
         }
       InvalidateRect(hWnd, NULL, TRUE);  /* invalidate window so that */
       break;                             /* if buffer changed the change */
                                          /* will be viewed */

     case  WM_DESTROY :        /* MESSAGE : destroy window received */
       PostQuitMessage(0);     /* send quit message */
       break;

     case  WM_DDE_ACK :        /* MESSAGE : DDE acknowledge received */
       hWndServer = wParam;
       if (fDoingInit)
          {
          wType = 26;               /* Inidicate that this is an INIT*/
          GlobalDeleteAtom(LOWORD(lParam));
          GlobalDeleteAtom(HIWORD(lParam));
          Show_Results ();
          fDoingInit = FALSE;
          }
       else
          {
          wType = 27;               /* All others are handled like   */
          *(WORD *)&wStatus = LOWORD(lParam); /* ADVISEs             */
          Show_Results();
          }
       if (fStillLocked == TRUE)
          {
          GlobalUnlock(hData);
          fStillLocked = FALSE;
          }
       break;

     case  WM_DDE_DATA :       /* MESSAGE : DDE data received */
       wType = 30;
       hDdeData = LOWORD(lParam);
       lpDdeData = (DDEDATA FAR *) GlobalLock(hDdeData);
       aItem = HIWORD(lParam);
       if (fDoingQuery == FALSE)
          {
          _fmemcpy(Buf, &lpDdeData->Value,
                   _fstrlen((char far *)&lpDdeData->Value));
          InvalidateRect(hWnd, NULL, TRUE);
          }
       Show_Results ();
       break;

     case  WM_DDE_TERMINATE :  /* MESSAGE : DDE terminate */
       wType = 33;
       Show_Results();
       break;

     default  :                /* this will handle any other messages */
       return  DefWindowProc(hWnd, wMsgID, wParam, lParam);
   }
  return 0;
}


/*========================================================================
  ParmDlgProc : this routine handles the inits the dialog boxes for the
                api commands and handles the input from the dialog boxes
=========================================================================*/
BOOL FAR PASCAL ParmDlgProc(HWND hWndDlg,WORD wMsgID,WORD wParam,LONG lParam)
{
  int  fp;
  HANDLE hWndTemp;
  WORD wNum;
  int i;
  char tempdata[60];
  char OutString[360];
  char RepChar[2];
  char filename[128];

  Trans = &Translated;
  switch (wMsgID)
    {
      case  WM_INITDIALOG :     /*MESSAGE: initialize dialog box */
        switch (wType)          /* now we use the type to decide */
          {                     /* which api we have */
            case 1 :            /* CREATE DQ */
                 /*set title of window */
              SetWindowText(hWndDlg, "Create Data Queue");
                 /* loop threw to get handle of each control field */
                 /* and hide the once used for keyed apis */
              hWndTemp = GetTopWindow(hWndDlg);
              for (i = 0; i < 16; i++)
                hWndTemp = GetNextWindow(hWndTemp, GW_HWNDNEXT);
              ShowWindow(hWndTemp, SW_HIDE);
              hWndTemp = GetNextWindow(hWndTemp, GW_HWNDNEXT);
              ShowWindow(hWndTemp, SW_HIDE);
              return  TRUE;

  /* NOTE: comments will be limited threw the init process */
  /*       because they don't much different               */

            case 2 :      /*  CREATE KEYED  */
              SetWindowText(hWndDlg, "Create Keyed Data Queue");
              hWndTemp = GetTopWindow(hWndDlg);
              for (i = 0; i < 6; i++)
                hWndTemp = GetNextWindow(hWndTemp, GW_HWNDNEXT);
              ShowWindow(hWndTemp, SW_HIDE);
              hWndTemp = GetNextWindow(hWndTemp, GW_HWNDNEXT);
              ShowWindow(hWndTemp, SW_HIDE);
              return  TRUE;

            case 3 :       /* CLEAR DATA QUEUE */
              SetWindowText(hWndDlg, "Clear Data Queue");
              return  TRUE;

            case 4 :      /* DELETE DATA QUEUE */
              SetWindowText(hWndDlg, "Delete Data Queue");
              return  TRUE;

            case 5 :      /* SEND TO DATA QUEUE */
              SetWindowText(hWndDlg, "Send to Data Queue");
              hWndTemp = GetTopWindow(hWndDlg);
              for (i = 0; i < 12; i++)
                hWndTemp = GetNextWindow(hWndTemp, GW_HWNDNEXT);
              ShowWindow(hWndTemp, SW_HIDE);
              hWndTemp = GetNextWindow(hWndTemp, GW_HWNDNEXT);
              ShowWindow(hWndTemp, SW_HIDE);
              return  TRUE;

            case 6 :     /* SEND TO KEYED DATA QUEUE */
              SetWindowText(hWndDlg, "Send to Keyed Data Queue");
              return  TRUE;

            case 7 :    /* PUT TO DATA QUEUE */
              SetWindowText(hWndDlg, "Put to Data Queue");
              hWndTemp = GetTopWindow(hWndDlg);
              for (i = 0; i < 12; i++)
                hWndTemp = GetNextWindow(hWndTemp, GW_HWNDNEXT);
              ShowWindow(hWndTemp, SW_HIDE);
              hWndTemp = GetNextWindow(hWndTemp, GW_HWNDNEXT);
              ShowWindow(hWndTemp, SW_HIDE);
              return  TRUE;

            case 8 :           /* PUT TO KEYED DATA QUEUE */
              SetWindowText(hWndDlg, "Put to Keyed Data Queue");
              return  TRUE;

            case 9 :       /* RECEIVE FROM DATA QUEUE */
              SetWindowText(hWndDlg, "Receive from Data Queue");
              return  TRUE;

            case 10 :      /* RECEIVE FROM KEYED DATA QUEUE */
              SetWindowText(hWndDlg, "Receive from Keyed Data Queue");
              return  TRUE;

            case 11 :    /* RECEIVE REQUEST FROM DATA QUEUE */
              SetWindowText(hWndDlg,"Receive Request from Data Queue");
              return  TRUE;

            case 12 :  /* RECEIVE REQUEST FORM KEYED DATA QUEUE */
              SetWindowText(hWndDlg,"Receive Request from Keyed Data Queue");
              return  TRUE;

            case 13 :   /* RECEIVE DATA */
              SetWindowText(hWndDlg, "Receive Previous Request");
              return  TRUE;

            case 14 :    /* RECEIVE DATA KEYED */
              SetWindowText(hWndDlg, "Receive Previous Request Keyed");
              return  TRUE;

            case 15 :    /* QUERY DATA QUEUE */
              SetWindowText(hWndDlg, "Query Data Queue");
              return  TRUE;

            case 16 :    /* SET CONVERSION MODE */
              SetWindowText(hWndDlg, "Set Conversion Mode");
              return  TRUE;

            case 17 :  /* GET MESSAGE */
              SetWindowText(hWndDlg, "Get Message");
              hWndTemp = GetTopWindow(hWndDlg);
              ShowWindow(hWndTemp, SW_HIDE);
              hWndTemp = GetNextWindow(hWndTemp, GW_HWNDNEXT);
              ShowWindow(hWndTemp, SW_HIDE);
              return  TRUE;

            case 18 :  /* STOP DATA QUEUES CONVERSATION */
              SetWindowText(hWndDlg, "Stop Conversation");
              hWndTemp = GetTopWindow(hWndDlg);
              ShowWindow(hWndTemp, SW_HIDE);
              hWndTemp = GetNextWindow(hWndTemp, GW_HWNDNEXT);
              ShowWindow(hWndTemp, SW_HIDE);
              return  TRUE;

            case 19 :  /* ADJUST BUFFER SIZE */
              SetWindowText(hWndDlg, "Adjust Buffer Size");
              return  TRUE;

            case 23 :   /* CANCEL REQUEST */
              SetWindowText(hWndDlg, "Cancel Request");
              return  TRUE;

            case 24 :    /* CANCEL REQUEST KEYED */
              SetWindowText(hWndDlg, "Cancel Request Keyed");
              return  TRUE;

            case 26 :    /* DDE INITIATE */
              SetWindowText(hWndDlg, "DDE Initiate");
              return  TRUE;

            case 27 :    /* DDE ADVISE */
              SetWindowText(hWndDlg, "DDE Advise");
              return  TRUE;

            case 28 :    /* DDE UNADVISE */
              SetWindowText(hWndDlg, "DDE Unadvise");
              return  TRUE;

            case 29 :    /* DDE EXECUTE */
              SetWindowText(hWndDlg, "DDE Execute");
              return  TRUE;

            case 30 :    /* DDE ACKNOWLEDGE */
              SetWindowText(hWndDlg, "DDE Acknowledge");
              return  TRUE;


            case 31 :    /* DDE REQUEST */
              SetWindowText(hWndDlg, "DDE Request");
              return  TRUE;

            case 32 :    /* DDE POKE */
              SetWindowText(hWndDlg, "DDE Poke");
              return  TRUE;

          }
        return  FALSE;

      case  WM_COMMAND :    /* MESSAGE : the dialog box has been processed */
        switch (wParam)
          {
            case  OK_ID :  /* user selected OK button to enter data */
              switch (wType)
                {
                  case 1 :     /* if either create or create keyed */
                  case 2 :     /* retrieve the data from the fields */
/* queue name */    wNum = GetDlgItemText(hWndDlg, CR_DQNAME, (LPSTR)DQ_Name, 40);
                    DQ_Name[wNum] = NULL;
/* system name */   wNum = GetDlgItemText(hWndDlg, CR_SYSNAME, (LPSTR)Sys_Name, 20);
                    Sys_Name[wNum] = NULL;
/* max length */    wNum = GetDlgItemText(hWndDlg, CR_MAXLEN, (LPSTR)LongData, 20);
                    LongData[wNum] = NULL;
                    i = 0;              /* need to convert text to long int */
                    MaxLength = 0L;
                    while ((i < 10) && (isdigit(LongData[i])))
                      {  MaxLength = MaxLength *10+(LongData[i]-48);
                         i++;
                      }
/* sequence */      Sequence = GetDlgItemInt(hWndDlg, CR_SEQUENCE, Trans, 1);
/* force */         Force = GetDlgItemInt(hWndDlg, CR_FORCE, Trans, 1);
/* authority */     Authority = GetDlgItemInt(hWndDlg, CR_AUTHORITY, Trans, 1);
/* send id */       SendId = GetDlgItemInt(hWndDlg, CR_SENDID, Trans,  1);
/* description */   wNum = GetDlgItemText(hWndDlg, CR_DESC, (LPSTR)Description, 100);
                    Description[wNum] = NULL;
/* Null handle */   Send_Null_Win = IsDlgButtonChecked(hWndDlg, CR_NULLWIN);
/* if createkey */  if (wType == 2)
/* key length */      KeyLength = GetDlgItemInt(hWndDlg, CR_KEYLEN, Trans, 1);
                    break;


                  case 3 :   /* if CLEAR, DELETE, RECEIVE DATA or QUERY */
                  case 4 :
                  case 13 :
                  case 15 :
                  case 23 :
/* queue name */    wNum = GetDlgItemText(hWndDlg, DS_DQNAME, (LPSTR)DQ_Name, 40);
                    DQ_Name[wNum] = NULL;
/* system name */   wNum = GetDlgItemText(hWndDlg, DS_SYSNAME, (LPSTR)Sys_Name, 20);
                    Sys_Name[wNum] = NULL;
/* null handle */   Send_Null_Win = IsDlgButtonChecked(hWndDlg, DS_NULLWIN);
                    break;

                  case 14 :         /* if RECEIVE DATA KEYED */
                  case 24 :         /* if CANCEL REQUEST KEYED */
/* queue name */    wNum = GetDlgItemText(hWndDlg, PV_DQNAME, (LPSTR)DQ_Name, 40);
                    DQ_Name[wNum] = NULL;
/* system name */   wNum = GetDlgItemText(hWndDlg, PV_SYSNAME, (LPSTR)Sys_Name, 20);
                    Sys_Name[wNum] = NULL;
/* key name */      wNum = GetDlgItemText(hWndDlg, PV_KEYNAME, (LPSTR)Key_Name, 300);
                    Key_Name[wNum] = NULL;
/* null handle */   Send_Null_Win = IsDlgButtonChecked(hWndDlg, PV_NULLWIN);
                    break;

                  case 5 :  /* if SEND, SEND KEYED, PUT or PUT KEYED */
                  case 6 :
                  case 7 :
                  case 8 :
/* queue name */    wNum = GetDlgItemText(hWndDlg, SP_DQNAME, (LPSTR)DQ_Name, 40);
                    DQ_Name[wNum] = NULL;
/* system name */   wNum = GetDlgItemText(hWndDlg, SP_SYSNAME, (LPSTR)Sys_Name, 20);
                    Sys_Name[wNum] = NULL;
/* buffer length - then convert the text into a long integer */
                    wNum = GetDlgItemText(hWndDlg, SP_BUFLEN, (LPSTR)LongData, 20);
                    LongData[wNum] = NULL;
                    i = 0;
                    BufLength = 0L;
                    while ((i < 10) && (isdigit(LongData[i])))
                      {  BufLength = BufLength *10+(LongData[i]-48);
                         i++;
                      }
/* check how the user wants to fill the buffer */
                    Repeat_Fill = IsDlgButtonChecked(hWndDlg, SP_REPEAT);
                    Input_Fill = IsDlgButtonChecked(hWndDlg, SP_INPUT);
                    Manual_Fill = IsDlgButtonChecked(hWndDlg, SP_MANUAL);
/* if Manual fill then read the data field */
                    if (Manual_Fill)
                      wNum = GetDlgItemText(hWndDlg, SP_DATA, Buf, buf_size);
/* if repeat fill then read character from data field and fill buffer */
                    if (Repeat_Fill)
                     {  v = Buf;      /* set v pointer to begining of buf */
                        wNum = GetDlgItemText(hWndDlg, SP_DATA, RepChar, 2);
                        i = 0;
                        while ((i < buf_size) && (i < BufLength))
                          {  *v++ = RepChar[0];
                             i++;
                          }
                      }
/* if input fill then read data field for file name of input data */
                    if (Input_Fill)
                      {
                        wNum = GetDlgItemText(hWndDlg, SP_DATA, filename, 128);
        /* open the file, if error display message */
                        if ((fp = _lopen(filename, OF_READ)) == -1)
                          { MessageBox(hWnd1, "File processing error.",
                                       "OPEN", MB_OK|MB_ICONHAND);
                            EndDialog(hWndDlg, FALSE);
                            return FALSE;
                          }
                        else
        /* if file opened then fill buffer with input file */
                          {  _lread(fp, Buf, (WORD) BufLength);
        /* close the file */
                             if ( _lclose(fp) == -1)
                                MessageBox(hWnd1, "File processing error.",
                                           "CLOSE", MB_OK|MB_ICONHAND);
                          }
                      }
/* if SEND KEYED OR PUT KEYED read the keyname */
                    if ((wType == 6) || (wType == 8))
                      wNum = GetDlgItemText(hWndDlg, SP_KEYNAME, (LPSTR)Key_Name,300);
                    Key_Name[wNum] = NULL;
/* null handle */   Send_Null_Win = IsDlgButtonChecked(hWndDlg, SP_NULLWIN);
                    break;

                  case 9 :     /* if RECEIVE or RECEIVE REQUEST */
                  case 11 :
/* queue name */    wNum = GetDlgItemText(hWndDlg, RC_DQNAME, (LPSTR)DQ_Name, 40);
                    DQ_Name[wNum] = NULL;
/* system name */   wNum = GetDlgItemText(hWndDlg, RC_SYSNAME, (LPSTR)Sys_Name, 20);
                    Sys_Name[wNum] = NULL;
/* sender id */     SendId = GetDlgItemInt(hWndDlg, RC_SENDID, Trans, 1);
/* wait time */     wNum = GetDlgItemText(hWndDlg, RC_WAITTIME, (LPSTR)LongData, 20);
                    LongData[wNum] = NULL;
                    i = 0;                   /* convert to long integer */
                    WaitTime = 0;
                    nNegativeFlag = 0;

                    while ((LongData[i] == ' ') || (LongData[i] == 0x00))
                    {
                     i++;
                    }

                    if (LongData[i] == '-')
                    {
                     i++;
                     nNegativeFlag = 1;
                    }

                    while ((i < 10) && (isdigit(LongData[i])))
                    {  WaitTime = WaitTime *10+(LongData[i]-48);
                         i++;
                    }

                    if (nNegativeFlag == 1)
                    {
                     WaitTime = WaitTime * (-1);
                    }

/* buffer length - then convert the text into a long integer */
                    wNum = GetDlgItemText(hWndDlg, RC_BUFLEN, (LPSTR)LongData, 20);
                    LongData[wNum] = NULL;
                    i = 0;
                    RcvBufLength = 0L;
                    while ((i < 10) && (isdigit(LongData[i])))
                      {  RcvBufLength = RcvBufLength *10+(LongData[i]-48);
                         i++;
                      }
/* null handle */   Send_Null_Win = IsDlgButtonChecked(hWndDlg, RC_NULLWIN);
                    break;

                  case 10 :  /* if RECEIVE KEYED or RECEIVE REQUEST KEYED */
                  case 12 :
/* queue name */    wNum = GetDlgItemText(hWndDlg, RK_DQNAME, (LPSTR)DQ_Name, 40);
                    DQ_Name[wNum] = NULL;
/* system name */   wNum = GetDlgItemText(hWndDlg, RK_SYSNAME, (LPSTR)Sys_Name, 20);
                    Sys_Name[wNum] = NULL;
/* sender id */     SendId = GetDlgItemInt(hWndDlg, RK_SENDID, Trans, 1);
                    wNum = GetDlgItemText(hWndDlg, RK_KEYNAME, (LPSTR)Key_Name, 300);
/* key name */      Key_Name[wNum] = NULL;
/* wait time */     wNum = GetDlgItemText(hWndDlg, RK_WAITTIME, (LPSTR)LongData, 20);
                    LongData[wNum] = NULL;
                    i = 0;               /* convert to long integer */
                    WaitTime = 0;
                    nNegativeFlag = 0;

                    while ((LongData[i] == ' ') || (LongData[i] == 0x00))
                    {
                     i++;
                    }

                    if (LongData[i] == '-')
                    {
                     i++;
                     nNegativeFlag = 1;
                    }

                    while ((i < 10) && (isdigit(LongData[i])))
                    {  WaitTime = WaitTime *10+(LongData[i]-48);
                         i++;
                    }

                    if (nNegativeFlag == 1)
                    {
                     WaitTime = WaitTime * (-1);
                    }

/* buffer length - then convert the text into a long integer */
                    wNum = GetDlgItemText(hWndDlg, RK_BUFLEN, (LPSTR)LongData, 20);
                    LongData[wNum] = NULL;
                    i = 0;
                    RcvBufLength = 0L;
                    while ((i < 10) && (isdigit(LongData[i])))
                      {  RcvBufLength = RcvBufLength *10+(LongData[i]-48);
                         i++;
                      }
/* search order */  wNum = GetDlgItemText(hWndDlg,RK_SEARCHO, (LPSTR)Search_Order,3);
                    Search_Order[wNum] = NULL;
/* null handle */   Send_Null_Win = IsDlgButtonChecked(hWndDlg, RK_NULLWIN);
                    break;

                  case 16 :  /* if SET CONVERSION MODE */
/* system name */   wNum = GetDlgItemText(hWndDlg, CM_SYSNAME, (LPSTR)Sys_Name, 20);
                    Sys_Name[wNum] = NULL;
/* conv. mode */    wNum = GetDlgItemText(hWndDlg, CM_MODE, (LPSTR)LongData, 20);
                    LongData[wNum] = NULL;
                    i = 0;            /* convert mode to long integer */
                    Mode = 0L;
                    while ((i < 10) && (isdigit(LongData[i])))
                      {  Mode = Mode * 10 + (LongData[i]-48);
                         i++;
                      }
/* null handle */   Send_Null_Win = IsDlgButtonChecked(hWndDlg, CM_NULLWIN);
                    break;


                  case 17 :   /* if GET MESSAGE or STOP */
                  case 18 :
/* system name */   wNum = GetDlgItemText(hWndDlg, DS_SYSNAME, (LPSTR)Sys_Name, 20);
                    Sys_Name[wNum] = NULL;
/* null handle */   Send_Null_Win = IsDlgButtonChecked(hWndDlg, DS_NULLWIN);
                    break;

                  case 19 :  /* if ADJUST BUFFER SIZE */
                    buf_size = GetDlgItemInt(hWndDlg, AB_BUFSIZE, Trans, 0);
                    break;

                  case 26 :  /* if DDE INIT */
                    wNum = GetDlgItemText(hWndDlg,
                                          DDE_APP,
                                          (LPSTR)App_Name,
                                          60);
                    App_Name[wNum] = NULL;
                    wNum = GetDlgItemText(hWndDlg,
                                          DDE_TOPIC,
                                          (LPSTR)Tpc_Name,
                                          60);
                    Tpc_Name[wNum] = NULL;
                    break;

                  case 27 :  /* if DDE ADVISE */
                    hDdeAdvise = GlobalAlloc (GHND | GMEM_DDESHARE,
                                              sizeof(DDEADVISE));
                    lpDdeAdvise = (DDEADVISE far *)
                      GlobalLock(hDdeAdvise);
                    wNum = GetDlgItemText(hWndDlg,
                                          DDE_PATHNAME,
                                          (LPSTR)Net_Name,
                                          300);
                    Net_Name[wNum] = NULL;
                    lpDdeAdvise->cfFormat =
                      GetDlgItemInt(hWndDlg,
                                    DDE_CF,
                                    Trans,
                                    0);
                    if (IsDlgButtonChecked(hWndDlg,
                                           ADV_ACKREQ) > 0)
                       {
                       lpDdeAdvise->fAckReq = 1;
                       }
                    else
                       {
                       lpDdeAdvise->fAckReq = 0;
                       }
                    GlobalUnlock(hDdeAdvise);
                    break;

                  case 28 :  /* if DDE UNADVISE */
                    wNum = GetDlgItemText(hWndDlg,
                                          DDE_PATHNAME,
                                          (LPSTR)Net_Name,
                                          300);
                    Net_Name[wNum] = NULL;
                    cfClipBd = GetDlgItemInt(hWndDlg,
                                             DDE_CF,
                                             Trans,
                                             0);
                    break;

                  case 29 :  /* if DDE EXECUTE */
                    hCommands = GlobalAlloc (GHND | GMEM_DDESHARE,
                                             sizeof(Cmd_Str));
                    lpCommands = (char far *)
                      GlobalLock(hCommands);
                    wNum = GetDlgItemText(hWndDlg,
                                          DDE_CMDSTR,
                                          (LPSTR)Cmd_Str,
                                          1024);
                    Cmd_Str[wNum] = NULL;
                    _fmemcpy(lpCommands,Cmd_Str,_fstrlen(Cmd_Str));
                    GlobalUnlock(hCommands);
                    break;

                  case 30 :  /* if DDE ACKNOWLEDGE */
                    wNum = GetDlgItemText(hWndDlg,
                                          DDE_ITEM,
                                          (LPSTR)Net_Name,
                                          300);
                    Net_Name[wNum] = NULL;
                    break;

                  case 31 :  /* if DDE REQUEST */
                    wNum = GetDlgItemText(hWndDlg,
                                          DDE_ITEM,
                                          (LPSTR)Net_Name,
                                          300);
                    Net_Name[wNum] = NULL;
                    cfClipBd = GetDlgItemInt(hWndDlg,
                                             DDE_CF,
                                             Trans,
                                             0);
                    if (IsDlgButtonChecked(hWndDlg,
                                           REQ_QUERY) > 0)
                       {
                       fDoingQuery = TRUE;
                       }
                    break;

                  case 32 :  /* if DDE POKE */
                    wNum = GetDlgItemText(hWndDlg,
                                          DDE_PATHNAME,
                                          (LPSTR)Net_Name,
                                          300);
                    Net_Name[wNum] = NULL;
                    wNum = GetDlgItemText(hWndDlg,
                                          DDE_ITEM,
                                          (LPSTR)szData,
                                          300);
                    szData[wNum] = NULL;
                    if (IsDlgButtonChecked(hWndDlg,
                                           POKE_RELEASE) > 0)
                       {
                       fRelease = 1;
                       }
                    else
                       {
                       fRelease = 0;
                       }
                    cfClipBd = GetDlgItemInt(hWndDlg,
                                             DDE_CF,
                                             Trans,
                                             0);
                    if (IsDlgButtonChecked(hWndDlg,
                                           POKE_RELDATA) == 0)
                       {
                       hData = GlobalAlloc(GHND|GMEM_DDESHARE,
                                            sizeof(szData+2));
                       }
                    else
                       {
                       hData = GlobalAlloc(GHND|GMEM_DDESHARE|GMEM_DISCARDABLE,
                                            sizeof(szData+2));
                       fStillLocked = TRUE;
                       }
                    lpData = (DDEPOKE far *)
                      GlobalLock(hData);
                    lpData->fRelease = fRelease;
                    lpData->cfFormat = cfClipBd;
                    _fmemcpy(lpData->Value,szData,_fstrlen(szData));
                    if (fStillLocked == FALSE)
                       {
                       GlobalUnlock(hData);
                       }
                    break;
                }
        /* set long pointers to array names */
              lpDQ_Name = (LPSTR)DQ_Name;
              lpSys_Name =(LPSTR)Sys_Name;
              lpDesc = (LPSTR)Description;
              lpKey_Name = (LPSTR)Key_Name;
              lpSearchO = (LPSTR)Search_Order;

              EndDialog(hWndDlg, TRUE);   /* end dialog - ok */
              return  TRUE;

            case  CANCEL_ID :
              EndDialog(hWndDlg, FALSE);   /* end dialog - cancel */
              return  FALSE;

            default  :
              return  FALSE;
          }
    }
  return  FALSE;
}

/*========================================================================
   FileDlgProc : this routine handles the inits the dialog boxes for the
                 execute and get variation menu options

    NOTE : This entire procedure is based on a sample program in SDK
           Thus, very few comments...
=========================================================================*/
BOOL FAR PASCAL FileDlgProc(HWND hWndDlg,WORD wMsgID,WORD wParam,LONG lParam)
{
  HANDLE hWndTemp;
  WORD wNum;
  int i;
  char tempdata[60];
  char OutString[360];
  HANDLE hFile = 1;

  Trans = &Translated;
  switch (wMsgID)
    {
      case  WM_INITDIALOG :  /* MESSAGE : init dialogs */
        switch (wType)
          {
            case 20 :         /* IF EXECUTE BATCH FILE */
              UpdateListBox(hWndDlg);
              SetDlgItemText(hWndDlg, EX_FILE, Def_Spec);
              SendDlgItemMessage(hWndDlg, EX_FILE, EM_SETSEL,
                                 NULL, MAKELONG(0, 0x7fff));
              SetFocus(GetDlgItem( hWndDlg, EX_FILE));
              return  FALSE;

            case 21 :         /* if GET VARIATIONS */
              UpdateListBox(hWndDlg);
              SetDlgItemText(hWndDlg, GV_FILE,  Def_Spec);
              SendDlgItemMessage(hWndDlg, GV_FILE, EM_SETSEL,
                                  NULL,  MAKELONG(0, 0x7fff));
               SetFocus(GetDlgItem( hWndDlg, GV_FILE));
              return  FALSE;
          }
        return  FALSE;

      case  WM_COMMAND :
        switch (wParam)
          {
            case  EX_LIST :
              switch (HIWORD(lParam))
                {
                  case  LBN_SELCHANGE :
                    if (DlgDirSelect(hWndDlg, str, EX_LIST))
                      strcat(str, Def_Spec);
                    SetDlgItemText(hWndDlg, EX_FILE, str);
                    SendDlgItemMessage(hWndDlg, EX_FILE, EM_SETSEL,
                                        NULL, MAKELONG(0, 0x7fff));
                    break;

                  case  LBN_DBLCLK :
                    goto OPEN;      /* YES they used a GOTO! */
                }
              return  TRUE;

            case  GV_LIST :
              switch (HIWORD(lParam))
                {
                  case  LBN_SELCHANGE :
                    if (DlgDirSelect(hWndDlg, str, GV_LIST))
                      strcat(str, Def_Spec);
                    SetDlgItemText(hWndDlg, GV_FILE, str);
                    SendDlgItemMessage(hWndDlg, GV_FILE, EM_SETSEL,
                                       NULL, MAKELONG(0, 0x7fff));
                    break;

                  case  LBN_DBLCLK :
                    goto OPEN;            /* OH MY not another one! */
                }
              return  TRUE;

            case  OK_ID :
OPEN:    /*  <----------------------- this is where the GOTOs jump to */
              if (wType == 20)
                {
                wNum = GetDlgItemText(hWndDlg, EX_FILE, Open_Name,  128);
                wNum = GetDlgItemText(hWndDlg, EX_OUTFILE, Output_File, 128);
                }
              else
                {
                  wNum = GetDlgItemText(hWndDlg, GV_FILE, Open_Name, 128);
                  wNum = GetDlgItemText(hWndDlg, GV_VAR, Variation, 16);
                }
              if (strchr(Open_Name, '*') || strchr(Open_Name, '?'))
                {
                  SeparateFile(hWndDlg, (LPSTR)str,
                                        (LPSTR)Def_Spec,
                                        (LPSTR)Open_Name);
                  if (str[0])
                     strcpy(Def_Path, str);
                  UpdateListBox(hWndDlg);
                  return  TRUE;
                }

              if (!Open_Name[0])  return  TRUE;

              EndDialog(hWndDlg, TRUE);
              return  TRUE;

            case  CANCEL_ID :
              EndDialog(hWndDlg, FALSE);
              return  FALSE;

            default  :
              return  FALSE;
          }
    }
  return  FALSE;
}

/*========================================================================
 flush_buf : flushes buffer or inititializes it to blanks
=========================================================================*/
void flush_buf(void)
{
  register i;

  v = Buf;
  for (i = 1; i <= buf_size; i++)
    {  *v = ' ';
       v++;
    }
}

/*========================================================================
 adjust_buf : adjusts the buffer size to new size
=========================================================================*/
void adjust_buf()
{

  switch (wCurrentBuf)
  {
   case 1:
    GlobalUnlock(hBuf1);                 /* unlock buffer  */
    hBuf1 = GlobalReAlloc(hBuf1,         /* reallocate buf */
                          buf_size,
                          GMEM_MOVEABLE);
    buf_size  = GlobalSize(hBuf1);       /* set buf_size to what actually */
    buf_size1 = buf_size;                /* save new size                 */
    Buf = (char far *)GlobalLock(hBuf1); /* was allocated and lock it */
    break;

   case 2:
    GlobalUnlock(hBuf2);                 /* unlock buffer  */
    hBuf2 = GlobalReAlloc(hBuf2,         /* reallocate buf */
                          buf_size,
                          GMEM_MOVEABLE);
    buf_size  = GlobalSize(hBuf2);       /* set buf_size to what actually */
    buf_size2 = buf_size;                /* save new size                 */
    Buf = (char far *)GlobalLock(hBuf2); /* was allocated and lock it */
    break;

   case 3:
    GlobalUnlock(hBuf3);                 /* unlock buffer  */
    hBuf3 = GlobalReAlloc(hBuf3,         /* reallocate buf */
                          buf_size,
                          GMEM_MOVEABLE);
    buf_size  = GlobalSize(hBuf3);       /* set buf_size to what actually */
    buf_size3 = buf_size;                /* save new size                 */
    Buf = (char far *)GlobalLock(hBuf3); /* was allocated and lock it */
    break;

   case 4:
    GlobalUnlock(hBuf4);                 /* unlock buffer  */
    hBuf4 = GlobalReAlloc(hBuf4,         /* reallocate buf */
                          buf_size,
                          GMEM_MOVEABLE);
    buf_size  = GlobalSize(hBuf4);       /* set buf_size to what actually */
    buf_size4 = buf_size;                /* save new size                 */
    Buf = (char far *)GlobalLock(hBuf4); /* was allocated and lock it */
    break;

   case 5:
    GlobalUnlock(hBuf5);                 /* unlock buffer  */
    hBuf5 = GlobalReAlloc(hBuf5,         /* reallocate buf */
                          buf_size,
                          GMEM_MOVEABLE);
    buf_size  = GlobalSize(hBuf5);       /* set buf_size to what actually */
    buf_size5 = buf_size;                /* save new size                 */
    Buf = (char far *)GlobalLock(hBuf5); /* was allocated and lock it */
    break;

  }

    /* readjust the following for painting purposes */
  NUMLINES = buf_size/16;
  nVscrollMax = max(0, NUMLINES+5-cyClient/cyChar);
  nVscrollPos = min(nVscrollPos, nVscrollMax);
  SetScrollRange(hWnd1, SB_VERT, 0, nVscrollMax, FALSE);
  SetScrollPos(hWnd1, SB_VERT, nVscrollPos, TRUE);
}

/*========================================================================
 Run_Command : calls the appropriate api function according to the cmd
               variable which is passed the wtype assign above
=========================================================================*/
int Run_Command(int cmd)
{
  HANDLE hWndtemp;

  if (Send_Null_Win)      /* decide if we need to send a NULL window */
    hWndtemp = NULL;      /* handle or send the programs valid one   */
  else
    hWndtemp = hWnd1;

  switch (cmd)            /* the following is pretty easy to figure out */
    {                     /* notice these are returns...thus no breaks  */
      case 1 :
        return  EHNDQ_Create(hWndtemp,
                             (LPSTR)DQ_Name,
                             (LPSTR)Sys_Name,
                             MaxLength,
                             Sequence,
                             Force,
                             Authority,
                             SendId,
                             (LPSTR)Description);
      case 2 :
        return  EHNDQ_CreateKeyed(hWndtemp,
                                  (LPSTR)DQ_Name,
                                  (LPSTR)Sys_Name,
                                  MaxLength,
                                  Force,
                                  Authority,
                                  SendId,
                                  (LPSTR)Description,
                                  KeyLength);
      case 3 :
        return  EHNDQ_Clear(hWndtemp,
                            (LPSTR)DQ_Name,
                            (LPSTR)Sys_Name);
      case 4 :
        return  EHNDQ_Delete(hWndtemp,
                             (LPSTR)DQ_Name,
                             (LPSTR)Sys_Name);
      case 5 :
        return  EHNDQ_Send(hWndtemp,
                           (LPSTR)DQ_Name,
                           (LPSTR)Sys_Name,
                           Buf,
                           BufLength);
      case 6 :
        return  EHNDQ_SendKeyed(hWndtemp,
                                (LPSTR)DQ_Name,
                                (LPSTR)Sys_Name,
                                Buf,
                                BufLength,
                                (LPSTR)Key_Name);
      case 7 :
        return  EHNDQ_Put(hWndtemp,
                          (LPSTR)DQ_Name,
                          (LPSTR)Sys_Name,
                          Buf,
                          BufLength);
      case 8 :
        return  EHNDQ_PutKeyed(hWndtemp,
                               (LPSTR)DQ_Name,
                               (LPSTR)Sys_Name,
                               Buf,
                               BufLength,
                               (LPSTR)Key_Name);
      case 9 :
        _fmemset((LPSTR)lpachSenderInfo, ' ', 36);
        _fstrcpy((LPSTR)lpszRecKey_Name, " ");
        *lplRecLength = RcvBufLength;
        return  EHNDQ_Receive(hWndtemp,
                              (LPSTR)DQ_Name,
                              (LPSTR)Sys_Name,
                              WaitTime,
                              SendId,
                              Buf,
                              lplRecLength,
                              (LPSTR)lpachSenderInfo);

      case 10 :
        _fmemset((LPSTR)lpachSenderInfo, ' ', 36);
        _fmemset((LPSTR)lpszRecKey_Name, ' ', 300);
        *lplRecLength = RcvBufLength;
        return  EHNDQ_ReceiveKeyed(hWndtemp,
                                   (LPSTR)DQ_Name,
                                   (LPSTR)Sys_Name,
                                   WaitTime,
                                   (LPSTR)Key_Name,
                                   (LPSTR)Search_Order,
                                   SendId,
                                   Buf,
                                   lplRecLength,
                                   (LPSTR)lpszRecKey_Name,
                                   (LPSTR)lpachSenderInfo);

      case 11 :
        _fmemset((LPSTR)lpachSenderInfo, ' ', 36);
        _fstrcpy((LPSTR)lpszRecKey_Name, " ");
        *lplRecLength = RcvBufLength;
        nRC = EHNDQ_ReceiveRequest(hWndtemp,
                                   (LPSTR)DQ_Name,
                                   (LPSTR)Sys_Name,
                                   WaitTime,
                                   SendId,
                                   Buf,
                                   lplRecLength,
                                   (LPSTR)lpachSenderInfo);
        *lplRecLength = 0L;
        return(nRC);

      case 12 :
        _fmemset((LPSTR)lpachSenderInfo, ' ', 36);
        _fmemset((LPSTR)lpszRecKey_Name, ' ', 300);
        *lplRecLength = RcvBufLength;
        nRC = EHNDQ_ReceiveRequestKeyed(hWndtemp,
                                        (LPSTR)DQ_Name,
                                        (LPSTR)Sys_Name,
                                        WaitTime,
                                        (LPSTR)Key_Name,
                                        (LPSTR)Search_Order,
                                        SendId,
                                        Buf,
                                        lplRecLength,
                                        (LPSTR)lpszRecKey_Name,
                                        (LPSTR)lpachSenderInfo);
         *lplRecLength = 0L;
         return(nRC);

      case 13 :
      case 14 :
        if (cmd == 13)
           return  EHNDQ_ReceiveData(hWndtemp,
                                     (LPSTR)DQ_Name,
                                     (LPSTR)Sys_Name);
        else
           return  EHNDQ_ReceiveDataKeyed(hWndtemp,
                                          (LPSTR)DQ_Name,
                                          (LPSTR)Sys_Name,
                                          (LPSTR)Key_Name);
      case 23 :
      case 24 :
        if (cmd == 23)
           return  EHNDQ_CancelRequest(hWndtemp,
                                      (LPSTR)DQ_Name,
                                      (LPSTR)Sys_Name);
        else
           return  EHNDQ_CancelRequestKeyed(hWndtemp,
                                            (LPSTR)DQ_Name,
                                            (LPSTR)Sys_Name,
                                            (LPSTR)Key_Name);
      case 15 :
        MaxLength = 0L;                  /* initialize return vars */
        Sequence = 0;
        Force = 0;
        SendId = 0;
        _fmemset((LPSTR)Description, ' ', 52);
        KeyLength = 0;
        return  EHNDQ_Query(hWndtemp,
                            (LPSTR)DQ_Name,
                            (LPSTR)Sys_Name,
                            &MaxLength,
                            &Sequence,
                            &Force,
                            &SendId,
                            (LPSTR)Description,
                            &KeyLength);
      case 16 :
        return  EHNDQ_SetMode(hWndtemp,
                              (LPSTR)Sys_Name,
                              Mode);
      case 17 :
        _fmemset(msgd, ' ', 152);        /* initialize return vars */
        return  EHNDQ_GetMessage(hWndtemp,
                                 (LPSTR)Sys_Name,
                                 MsgData,
                                 &MsgLength);
      case 18 :
        return  EHNDQ_Stop(hWndtemp,
                           (LPSTR)Sys_Name);

      case 22 :
        return  EHNDQ_GetCapability(hWndtemp,
                                    &FuncLevel);

      case 26 :
        aApp = GlobalAddAtom(App_Name);
        aTop = GlobalAddAtom(Tpc_Name);
        fDoingInit = TRUE;
        SendMessage (0xFFFF,
                     WM_DDE_INITIATE,
                     hWndtemp,
                     MAKELONG(aApp, aTop));
        return  0;

      case 27 :
        aItem = GlobalAddAtom(Net_Name);
        PostMessage (hWndServer,
                     WM_DDE_ADVISE,
                     hWndtemp,
                     MAKELONG(hDdeAdvise,aItem));
        return  0;

      case 28 :
        aItem = GlobalAddAtom(Net_Name);
        PostMessage (hWndServer,
                     WM_DDE_UNADVISE,
                     hWndtemp,
                     MAKELONG(cfClipBd,aItem));
        return  0;

      case 29 :
        PostMessage (hWndServer,
                     WM_DDE_EXECUTE,
                     hWndtemp,
                     MAKELONG(0,hCommands));
        return  0;

      case 30 :
        aItem = GlobalAddAtom(Net_Name);
        wStatus.fAck = TRUE;
        wStatus.bAppReturnCode = 0;
        PostMessage (hWndServer,
                     WM_DDE_ACK,
                     hWndtemp,
                     MAKELONG(*(WORD *)&wStatus,aItem));
        return  0;

      case 31 :
        aItem = GlobalAddAtom(Net_Name);
        PostMessage (hWndServer,
                     WM_DDE_REQUEST,
                     hWndtemp,
                     MAKELONG(cfClipBd,aItem));
        return  0;

      case 32 :  /* Poke */
        aItem = GlobalAddAtom(Net_Name);
        PostMessage (hWndServer,
                     WM_DDE_POKE,
                     hWndtemp,
                     MAKELONG(hData,aItem));
        return  0;

      case 33 :
        PostMessage (hWndServer,
                     WM_DDE_TERMINATE,
                     hWndtemp,
                     MAKELONG(0,0));
        return  0;

      default  :
        return 999;
    }
}

/*========================================================================
 Move SenderInfo : moves the sender info to the Jobname, user name etc.
=========================================================================*/
void MoveSenderInfo()
{
  _fmemcpy((LPSTR)SenderInfo, (LPSTR)lpachSenderInfo, 36);

  _fmemcpy((LPSTR)JobName, &SenderInfo[0], 10);/* first 10 -> job name */
  _fmemcpy((LPSTR)UserName, &SenderInfo[10], 10);/* next 10->user name */
  _fmemcpy((LPSTR)JobNum, &SenderInfo[20], 6); /* next   6 -> job number */
  _fmemcpy((LPSTR)UserProfile, &SenderInfo[26], 10);
                               /* last  10 -> user profile */
      /* make each variable a null terminated string */
  JobName[10] = NULL;
  UserName[10] = NULL;
  JobNum[6] = NULL;
  UserProfile[10] = NULL;
      /* set long pointers to each of the variable names */
  lpJobName = (LPSTR)JobName;
  lpUserName = (LPSTR)UserName;
  lpJobNum = (LPSTR)JobNum;
  lpUserProfile = (LPSTR)UserProfile;
  lpRecKey_Name = (LPSTR)lpszRecKey_Name;  /* put this here just because */
}

/*========================================================================
UpdateListBox: updates the list of files in the Execute and Get var
               dialog boxes.  NOTE: this was taken from an SDK sample
               program...thus no comments
=========================================================================*/
void UpdateListBox(HWND hDlg)
{
  strcpy(str, Def_Path);
  strcat(str, Def_Spec);
  if (wType == 19)        /* if execute batch file */
    DlgDirList(hDlg, (LPSTR)str, EX_LIST, EX_PATH, 0x4010);
  else                   /* else must be get variation */
    DlgDirList(hDlg, (LPSTR)str, GV_LIST, GV_PATH, 0x4010);
  if (!strchr(Def_Path, ':'))
    {
      if (wType == 19)    /* if for execute dialog box */
        DlgDirList(hDlg, (LPSTR)Def_Spec, EX_LIST, EX_PATH, 0x4010);
      else               /* else its for the get variation dialog box */
        DlgDirList(hDlg, (LPSTR)Def_Spec, GV_LIST, GV_PATH, 0x4010);
    }
  if (strstr(Def_Path, ".."))
    Def_Path[0] = '\0';
  if (wType == 19)
    SetDlgItemText(hDlg, EX_FILE, Def_Spec);
  else
    SetDlgItemText(hDlg, GV_FILE, Def_Spec);
}

/*========================================================================
 SeparateFile : this seperates the path from the file name.  Again taken
                from a sample program.  No comments.
=========================================================================*/
void SeparateFile(hDlg,lpDestPath,lpDestFileName,lpSrcFileName)
  HWND hDlg;
  LPSTR lpDestPath,lpDestFileName,lpSrcFileName;
{
  LPSTR lpTmp;
  char cTmp;

  lpTmp = lpSrcFileName+(LONG)lstrlen(lpSrcFileName);
  while (*lpTmp != ':' && *lpTmp != '\\' && lpTmp > lpSrcFileName)
    lpTmp = AnsiPrev(lpSrcFileName, lpTmp);
  if (*lpTmp != ':' && *lpTmp != '\\')
    {
      lstrcpy(lpDestFileName, lpSrcFileName);
      lpDestPath[0] = 0;
      return ;
    }
  lstrcpy(lpDestFileName, lpTmp+1);
  cTmp = *(lpTmp+1);
  lstrcpy(lpDestPath, lpSrcFileName);
  *(lpTmp+1) = cTmp;
  lpDestPath[(lpTmp-lpSrcFileName)+1] = 0;
}


/*========================================================================
  Get_Variation : this routine retrieves a filename, and variation name.
                  opens the file, reads it, finds the variation, and
                  allows the user to run it if he/she desires.
=========================================================================*/
void Get_Var()
{
BOOL FOUND = FALSE;
char SearchVar[16];
char tc;
char command[12];
int i,j;
int cmd_code;
BOOL Issue = TRUE;

     /* Read input file opens and reads file into a buffer */
if (Read_Input_File())      /* if open and read are successful continue */
  {
    do
      { get_id(SearchVar,&tc);      /* get id from input buffer */
        if (strncmp(Variation,SearchVar,16) == 0)   /* is the right one */
          { FOUND = TRUE;           /* if so set found flag */
          }
        else                       /* if not read to end of line so we */
          {  while ((tc != EOF) && (tc != EOLN))  /* are ready to get  */
                tc = Get_Char();                  /* next id at top of */
          }                                       /* the loop          */
      }
      while ((tc != EOF) && (!FOUND));   /* continue until found or EOF */

     if (FOUND)     /* if we found it get the variation data */
       {
         get_cmd(command);         /* get the command text */
         cmd_code = parse_cmd(command);   /* parse command and assign code */
         get_comment();            /* get variation comment */
         get_parms(cmd_code);      /* get rest of params depending on code */
            /* display the parameters and ask whether to run command */
         Issue = DisplayParams(cmd_code,command,SearchVar);
         if (Issue)   /* if user wants to run command */
          {  Run_Command(cmd_code);  /* call run command routien */
             Show_Results();         /* display return code */
          }
       }
     else   /* display message if variation is not in file */
       {  MessageBox(hWnd1, "Variation not found.",
                     NULL, MB_OK|MB_ICONHAND);
       }
  }
}

/*========================================================================
  get_id : gets the variation id out of batch file...we should be at
           the beginning of a line in the input file.
=========================================================================*/
void get_id(char tstid[], char *tch)
{
int  i = 0;
int  j = 0;
    /* initialize the test id and get the first character which will */
    /* serve as the delimiter between params for the rest of the var */
  memset(tstid, ' ' , 16);
  delimiter = *tch = Get_Char();
  do                      /* do until EOLN, EOF or more than 16 chars */
  {  *tch = Get_Char();
         /* ignore blanks and nulls */
     if ((i++ < 16) && ( *tch != ' ') && ( *tch != '\0') &&
        (*tch != EOLN) && (*tch != EOF))
     {     tstid[j++] = *tch;
     }
  }  while ((*tch != EOLN) && (*tch != EOF) && (i < 16));
  tstid[j] = '\0';   /* make null terminated */
}

/*========================================================================
   get_cmd : gets the api command out of batch file
=========================================================================*/
void get_cmd(char cmd[])
{                    /* if you notice all these gets are pretty much the */
char tch;            /* same and not hard to figure out */
int  i = 0;
int  j = 0;
  memset (cmd, ' ' , 11);
  tch = Get_Char();
  do
  {  tch = Get_Char();
     if ((i++ < 11) && ( tch != ' ') && ( tch != '\0') && (tch != EOLN) && (tch != EOF)) cmd[j++] = tch;
  }  while ((tch != EOLN) && (tch != EOF) && (i < 11));
  cmd[j] = '\0';
}


/*========================================================================
   parse_cmd : will parse the command text and assign in a cmd code
=========================================================================*/
int parse_cmd(char cmd[])
{

       if (strncmp("SPACE",cmd,11)    == 0) return 19;
  else if (strncmp("QSNDDTAQ",cmd,11) == 0) return  5;
  else if (strncmp("QPUTDTAQ",cmd,11) == 0) return  7;
  else if (strncmp("QSNDDQKY",cmd,11) == 0) return  6;
  else if (strncmp("QPUTDQKY",cmd,11) == 0) return  8;
  else if (strncmp("QRCVDTAQ",cmd,11) == 0) return  9;
  else if (strncmp("QRCVIMDQ",cmd,11) == 0) return 11;
  else if (strncmp("QRCVDQKY",cmd,11) == 0) return 10;
  else if (strncmp("QRCVIMKY",cmd,11) == 0) return 12;
  else if (strncmp("QCLRDTAQ",cmd,11) == 0) return  3;
  else if (strncmp("QQRYDTAQ",cmd,11) == 0) return 15;
  else if (strncmp("QDLTDTAQ",cmd,11) == 0) return  4;
  else if (strncmp("QCRTDTAQ",cmd,11) == 0) return  1;
  else if (strncmp("QCRTDQKY",cmd,11) == 0) return  2;
  else if (strncmp("QGETMSG", cmd,11) == 0) return 17;
  else if (strncmp("QSTPDTAQ",cmd,11) == 0) return 18;
  else if (strncmp("QRCVDATA",cmd,11) == 0) return 13;
  else if (strncmp("QRCVDATA",cmd,11) == 0) return 14;
  else if (strncmp("QSETMODE",cmd,11) == 0) return 16;
  else if (strncmp("STOP",    cmd,11) == 0) return 20;
  else if (strncmp("RESET",   cmd,11) == 0) return 21;
  else if (strncmp("SKIPON",  cmd,11) == 0) return 22;
  else if (strncmp("SKIPOFF", cmd,11) == 0) return 23;
  else if (strncmp("PAUSE",   cmd,11) == 0) return 24;
  else if (strncmp("WAIT",    cmd,11) == 0) return 25;
  else if (strncmp("          ",cmd,11)== 0) return 26;   /* the 26 is for */
  else if (strncmp("",cmd,11)== 0) return 26;            /* invalid commands */
  else if (strncmp("TESTAPI",cmd,11)== 0) return 26;
  else return 0;
}


/*========================================================================
  get_parms : will init show flags and get appropriate params for each cmd
=========================================================================*/
void get_parms(int cmdnum )
{
show_sendid = FALSE;  /* initialize the show flags to false */
show_seq    = FALSE;
show_force  = FALSE;
show_auth   = FALSE;
show_keylen = FALSE;
show_mode   = FALSE;
show_wait   = FALSE;
show_max    = FALSE;
show_len    = FALSE;
show_sys    = FALSE;
show_dq     = FALSE;
show_key    = FALSE;
show_text   = FALSE;
show_order  = FALSE;
Send_Null_Win = FALSE;

switch(cmdnum)
  {
    case  1:      /* get the creates' parameters and set show flags */
    case  2:
        get_bdq(); show_dq = TRUE;       /* get queue name */
        get_bsys(); show_sys = TRUE;        /* get system name */
        MaxLength = get_bulong(); show_max  = TRUE;   /* get max length */
        Sequence = get_bnum(); show_seq  = TRUE;    /* get sequence */
        Force = get_bnum(); show_force  = TRUE;     /* get force */
        Authority = get_bnum(); show_auth = TRUE;   /* get authority */
        SendId = get_bnum(); show_sendid = TRUE;    /* get send id */
        get_btext(); show_text = TRUE;          /* get description */
        if (cmdnum == 2)            /* if cmd is the keyed create */
           KeyLength = get_bnum(); show_keylen = TRUE;  /* get key length */
        break;

    case  3:
    case  4:       /* if CLEAR, DELETE, RECEIVE DATA, RECEIVE DATA KEYED */
    case  13:     /*  or QUERY DATA QUEUE */
    case  14:
    case  15:
        get_bdq(); show_dq = TRUE;             /* get queue name */
        get_bsys(); show_sys = TRUE;           /* get system name */
        if (cmdnum == 14)                      /* if receive data keyed */
            get_bkey(); show_key  = TRUE;      /* get key name */
        break;

    case  5:
    case  6:    /* if SEND, PUT, SEND KEYED, or PUT KEYED */
    case  7:
    case  8:
        get_bdq(); show_dq = TRUE;                 /* get queue name */
        BufLength = get_bulong(); show_len = TRUE; /* get buffer length */
        get_bsys(); show_sys = TRUE;               /* get system name */
        if ((cmdnum == 6) || (cmdnum == 8))        /* if keyed */
            get_bkey(); show_key  = TRUE;          /* get key name */
        get_bbuf();                             /* get buffer data */
        break;

    case  9:
    case  10: /* if RECEIVE, RECEIVE KEYED, RECEIVE REQUEST or */
    case  11: /*    RECEIVE REQUEST KEYED */
    case  12:
        get_bdq(); show_dq = TRUE;                 /* get queue name */
        get_bsys(); show_sys = TRUE;               /* get sytem name */
        WaitTime = get_blong(); show_wait = TRUE;  /* get wait time  */
        SendId = get_bnum(); show_sendid = TRUE;   /* get sender id  */
        if ((cmdnum == 10) || ( cmdnum == 12))     /* if keyed cmd  */
          {
             get_border(); show_order = TRUE;      /* get search order */
             get_bkey(); show_key = TRUE;          /* get keyname */
          }
        break;

    case  16:    /* if SET CONVERSION MODE */
        get_bsys(); show_sys = TRUE;               /* get system name */
        Mode = get_bulong(); show_mode = TRUE;     /* get mode */
        break;

    case  17:  /* if STOP or GET MESSAGE */
    case  18:
        get_bsys(); show_sys = TRUE;  /* get system */
        break;
    }
}


/*========================================================================
  get_comment : gets the variation comment from the batch file
=========================================================================*/
void get_comment()
{
char tc;
int  k = 0;

  memset (comment, ' ' , 72);
  tc = Get_Char();
  tc = Get_Char();
  while ((tc != EOLN) && (tc != EOF) && (k < 72) && (tc != delimiter))
  {  if (tc != '\0') comment[k++] = tc;
     tc = Get_Char();
  }
  comment[k] = '\0';
}


/*========================================================================
   get_bdq : will get the data queue name from the batch file
=========================================================================*/
void get_bdq()
{
char tc;
int  k = 0;

  tc = Get_Char();
  if (tc == delimiter) tc = get_next(tc);
  while ((tc != EOLN) && (tc != EOF) && (k < 32) && (tc != delimiter))
  {  if (tc != '\0') DQ_Name[k++] = tc;
     tc = Get_Char();
  }
  DQ_Name[k] = '\0';
}


/*========================================================================
   get_bsys : will get the system name from the batch file
=========================================================================*/
void get_bsys()
{
char tc;
int  k = 0;

  tc = Get_Char();
  if (tc == delimiter) tc = get_next(tc);
  while ((tc != EOLN) && (tc != EOF) && (k < 21) && (tc != delimiter))
  {  if (tc != '\0') Sys_Name[k++] = tc;
     tc = Get_Char();
  }
  Sys_Name[k] = '\0';
}


/*========================================================================
  get_bkey : will bet the key name from the batch file
=========================================================================*/
void get_bkey()
{
BOOL read_again;
char tc;
int  k = 0;

  tc = Get_Char();
  if (tc == delimiter) tc = get_next(tc);
  do
  {  read_again = FALSE;
     while ((tc != EOLN) && (tc != EOF) && (k < 257) && (tc != delimiter))
     {  if (tc != '\0') Key_Name[k++] = tc;
        tc = Get_Char();
     }
     if (tc = delimiter)
     {  tc = Get_Char();                       /* most of this junk here */
        if ((tc != EOF) && (tc != delimiter))  /* is the way Jeff P. set */
           UnGet_Char();                       /* up the batch files... */
        else                                   /* so what this does is */
           if (tc = delimiter)                    /* if the keyname spans */
           {  while ((tc != EOLN) && (tc != EOF))   /* more than one line */
                {  tc = Get_Char();             /* it is able to recongnize */
                }                              /* the double delimiters */
              tc = Get_Char();
              while ((tc != EOLN) && (tc != EOF) && (tc != delimiter))
                {  tc = Get_Char();
                }
              tc = Get_Char();
              if (tc != delimiter) read_again = TRUE;
           }
     }
  }  while (read_again);
  Key_Name[k] = '\0';
}


/*========================================================================
  get_bbuf : will get data from batch file and store in buffer
=========================================================================*/

void get_bbuf()
{
BOOL read_again;
char tc;
char far *p;
int  k = 0;

  p = Buf;
  tc = Get_Char();
  if (tc == delimiter) tc = get_next(tc);
  do
  {  read_again = FALSE;
     while ((tc != EOLN) && (tc != EOF) && (k < 257) && (tc != delimiter))
     {  if (tc != '\0') *p++ = tc;
        tc = Get_Char();
     }
     if (tc = delimiter)
     {  tc = Get_Char();
        if ((tc != EOF) && (tc != delimiter))
           UnGet_Char();
        else                      /* if it spans more than one line */
           if (tc = delimiter)
           {  while ((tc != EOLN) && (tc != EOF))  tc = Get_Char();
              tc = Get_Char();
              while ((tc != EOLN) && (tc != EOF) && (tc != delimiter)) tc = Get_Char();
              tc = Get_Char();
              if (tc != delimiter) read_again = TRUE;
           }
     }
  }  while (read_again);
  *p = '\0';
}



/*========================================================================
  get_btext : will get the data queue description from batch file
=========================================================================*/
void get_btext()
{
char tc;
int  k = 0;

  tc = Get_Char();
  if (tc == delimiter) tc = get_next(tc);
  while ((tc != EOLN) && (tc != EOF) && (k < 100) && (tc != delimiter))
  {  if (tc != '\0') Description[k++] = tc;
     tc = Get_Char();
  }
  Description[k] = '\0';
}


/*========================================================================
  get_border : will get the search order from the batch file
=========================================================================*/
void get_border()
{
char tc;
int  k = 0;

  tc = Get_Char();
  if (tc == delimiter) tc = get_next(tc);
  while ((tc != EOLN) && (tc != EOF)  && (tc != delimiter))
  {  if ((tc != ' ') && (k < 2) && (tc != '\0'))  Search_Order[k++] = tc;
     tc = Get_Char();
  }
  Search_Order[k] = '\0';
}


/*========================================================================
  get_bnum : will get an ordinary integer from the batch files
=========================================================================*/
int get_bnum()
{
char chnum[15];
char tc;
int  num;
int  k = 0;

  tc = Get_Char();
  if (tc == delimiter) tc = get_next(tc);
  while ((tc != EOLN) && (tc != EOF) && (tc != delimiter) && (k < 15))
  {  if ((tc != ' ') && (tc != '\0'))  chnum[k++] = tc;
     tc = Get_Char();
  }
  chnum[k] = '\0';
  num = atoi(chnum);
  return(num);
}


/*========================================================================
  get_blong : will get a signed long integer from the batch file
=========================================================================*/
long get_blong()
{
long lnum;
char chlnum[25];
char tc;
int  k = 0;

  tc = Get_Char();
  if (tc == delimiter) tc = get_next(tc);
  while ((tc != EOLN) && (tc != EOF) && (tc != delimiter) && (k < 25))
  {  if ((tc != ' ') && (tc != '\0')) chlnum[k++] = tc;
     tc = Get_Char();
  }
  chlnum[k] = '\0';
  lnum = atol(chlnum);
  return(lnum);
}


/*========================================================================
  get_bulong : will get an unsigned long integer from the batch file
=========================================================================*/
unsigned long get_bulong()
{
unsigned long lnum;
char chlnum[25];
char tc;
int  k = 0;

  tc = Get_Char();
  if (tc == delimiter) tc = get_next(tc);
  while ((tc != EOLN) && (tc != EOF) && (tc != delimiter) && (k < 25))
  {  if ((tc != ' ') && (tc != '\0')) chlnum[k++] = tc;
     tc = Get_Char();
  }
  chlnum[k] = '\0';
  lnum = atol(chlnum);
  return(lnum);
}


/*========================================================================
  get_next : will discard rest of line and read until it finds next param
=========================================================================*/
int get_next(int tmc)
{
  while ((tmc != EOLN) && (tmc != EOF))
    tmc = Get_Char();
  tmc = Get_Char();
  while ((tmc != EOLN) && (tmc != EOF) && (tmc != delimiter))
    tmc = Get_Char();
  tmc = Get_Char();
  return tmc;
}


/*========================================================================
   DisplayParams : will display the retrieved paramaters before running
=========================================================================*/
BOOL DisplayParams(int code,char cmd[],char tstid[])
{
LPSTR tmpptr1;
LPSTR tmpptr2;  /* temporay pointers used for wsprintf which */
LPSTR tmpptr3;  /* likes LPSTRs instead of array names */


  tmpptr1 = (LPSTR)outdata;
  tmpptr2 = tstid;
  tmpptr3 = cmd;

  wsprintf(tmpptr1,"Test ID : %s  Cmd : %s \n",tmpptr2,tmpptr3);
  tmpptr2 = (LPSTR)tmpdata;

  if (show_dq)                   /* if show flag is set */
    {  tmpptr3 = (LPSTR)DQ_Name; /* format the parameter properly */
       wsprintf(tmpptr2,"Queue : %s",tmpptr3);  /* and concatenate */
       lstrcat(tmpptr1,tmpptr2);   /* it with the output variable */
    }
  if (show_sys)                   /* same thing from here on out */
    {  tmpptr3 = (LPSTR)Sys_Name;
       wsprintf(tmpptr2,"System : %s ",tmpptr3);
       lstrcat(tmpptr1,tmpptr2);
    }
  if (show_max)
    {  wsprintf(tmpptr2,"\nMax Len   : %lu",MaxLength);
       lstrcat(tmpptr1,tmpptr2);
    }
  if (show_seq)
    {  wsprintf(tmpptr2,"Sequence  : %i",Sequence);
       lstrcat(tmpptr1,tmpptr2);
    }
  if (show_force)
    {  wsprintf(tmpptr2,"Force    : %i",Force);
       lstrcat(tmpptr1,tmpptr2);
    }
  if (show_auth)
    {  wsprintf(tmpptr2,"Authority : %i\n",Authority);
       lstrcat(tmpptr1,tmpptr2);
    }
  if (show_wait)
    {  wsprintf(tmpptr2,"\nWait time : %ld",WaitTime);
       lstrcat(tmpptr1,tmpptr2);
    }
  if (show_sendid)
    {  wsprintf(tmpptr2,"Send Id : %i",SendId);
       lstrcat(tmpptr1,tmpptr2);
    }
  if (show_keylen)
    {  wsprintf(tmpptr2,"Key Length : %i",KeyLength);
       lstrcat(tmpptr1,tmpptr2);
    }
  if (show_mode)
    {  wsprintf(tmpptr2,"Mode    : %lu",Mode);
       lstrcat(tmpptr1,tmpptr2);
    }
  if (show_len)
    {  wsprintf(tmpptr2,"Buffer Length : %ul",BufLength);
       lstrcat(tmpptr1,tmpptr2);
    }
  if (show_order)
    {  tmpptr3 = (LPSTR)Search_Order;
       wsprintf(tmpptr2,"Order     : %s",tmpptr3);
       lstrcat(tmpptr1,tmpptr2);
    }
  if(show_text)
    {  tmpptr3 = (LPSTR)Description;
       wsprintf(tmpptr2,"\nDescription : %s",tmpptr3);
       lstrcat(tmpptr1,tmpptr2);
    }
  if (show_key)
    {  tmpptr3 = (LPSTR)Key_Name;
       wsprintf(tmpptr2,"\nKey Name  : %s",tmpptr3);
       lstrcat(tmpptr1,tmpptr2);
    }
  return MessageBox(hWnd1,           /* display the parameters in outdata */
                    (LPSTR)outdata,
                    "Run Variation",
                     MB_OKCANCEL|MB_ICONQUESTION);

}

/*========================================================================
  Read_Input_File : will read in the input file and store in buffer
=========================================================================*/
int Read_Input_File()
{
int rc = 1;
   /* open input file and if error display message */
if ((Infp = OpenFile(Open_Name, &InOfStruct, OF_READ)) == -1)
  {  MessageBox(hWnd1, "File processing error.",
                "OPEN", MB_OK|MB_ICONHAND);
     rc = 0;
  }
else    /* if file was opened successfully */
  {
       /* get file length and allocate a buffer to hold it */
    InFileLen = FileLength(Infp);
    hInFileBuf = GlobalAlloc(GMEM_MOVEABLE,InFileLen);
      /* if unable to allocate buffer display error message */
    if (hInFileBuf == NULL)
      {  MessageBox(hWnd1, "File processing error.",
                    "ALLOCATE", MB_OK|MB_ICONHAND);
         rc = 0;
      }
    else
      {
         /* if everything ok lock buffer and read in the file */
       InFileBuf = (char far *) GlobalLock(hInFileBuf);
       _lread(Infp, InFileBuf, (WORD) InFileLen);
       InFilePos = InFileBuf;
       Char_Count = 0;
      }
         /* close the file if error display message */
    if ( _lclose(Infp) == -1)
      {  MessageBox(hWnd1, "File processing error.",
                    "CLOSE", MB_OK|MB_ICONHAND);
      }
  }
}


/*========================================================================
   FileLength : returns the lenght of a specified file
=========================================================================*/
long FileLength(int hFile)
{
long lCurrentPos;
long lFileLength;

   lCurrentPos = _llseek(hFile,0L, 1); /* move pointer to beginning */
   lFileLength = _llseek(hFile,0L, 2); /* moves pointer to end */
   _llseek(hFile, lCurrentPos, 0);     /* moves pointer back to were it was */
   return lFileLength;       /* return the file length */
}


/*========================================================================
   Get_Char : will return a character from the input buffer
=========================================================================*/
char Get_Char(void)
{
if (Char_Count < InFileLen)          /* if character count is less */
 {                                   /* than file length */
    Char_Count++;                    /* increase character count */
    return *InFilePos++;             /* and return current character */
 }                                   /* then increment buffer pointer */
else return EOF;                     /* else return end of file */
}


/*========================================================================
   UnGet_Char : will back up input buffer pointer by one
=========================================================================*/
void UnGet_Char(void)
{
  Char_Count--;      /* decrement character counter */
  InFilePos--;       /* backup infile buffer pointer */
}

/*========================================================================
  Show_Results : displays the return code and any values returned by a api
=========================================================================*/
void Show_Results(void)
{
switch(wType)
  {
    case 1 :
    case 2 :  /* for almost all the APIs just format the return code */
    case 3 :
    case 4 :
    case 5 :
    case 6 :
    case 7 :
    case 8 :
    case 11 :
    case 12 :
    case 16 :
    case 18 :
             wsprintf(OutputString, "Return Code = %i", DQ_RC);
            break;

    case 22 :
             wsprintf(OutputString,
                      "Return Code = %i\nFunctional Level = %i",
                      DQ_RC,
                      FuncLevel);
            break;

    case 26 :
             wsprintf(OutputString,
                      "DDE_INITIATE was successful");
            break;

    case 27 :
             if (wStatus.fAck == TRUE)
                {
                wsprintf(OutputString,
                         "DDE command was successful");
                }
             else
                {
                wsprintf(OutputString,
                         "DDE command failed\nReturn Code = %i",
                         wStatus.bAppReturnCode);
                }
            break;

    case 30 :
             GlobalGetAtomName(aItem,(LPSTR)szItem,nItem);
             GlobalDeleteAtom(aItem);
             if (fDoingQuery == TRUE)
                {
                wsprintf(OutputString,
                     "Query Item: \n%s\nMaximum Length = %lu\nSequence = %i\nForce = %i\nSendId = %i\nDescription = %s\nKey Length = %i",
                     (LPSTR)szItem,
                     ((QUERYSTRUCT far *)&lpDdeData->Value)->lMaxLength,
                     ((QUERYSTRUCT far *)&lpDdeData->Value)->nSequence,
                     ((QUERYSTRUCT far *)&lpDdeData->Value)->nForce,
                     ((QUERYSTRUCT far *)&lpDdeData->Value)->bSenderID,
                     (LPSTR)((QUERYSTRUCT far *)&lpDdeData->Value)->szText,
                     ((QUERYSTRUCT far *)&lpDdeData->Value)->nKeyLen);
                fDoingQuery = FALSE;
                }
             else if (lpDdeData->fAckReq == 1)
                {
                wsprintf(OutputString,
                  "Data returned for item:\n%s\nAn acknowledgement is requested",
                  (LPSTR)szItem);
                }
             else
                {
                wsprintf(OutputString,
                  "Data returned for item:\n%s\nAn acknowledgement is NOT needed",
                  (LPSTR)szItem);
                }
             GlobalUnlock(hDdeData);
             GlobalFree(hDdeData);
            break;

    case 33 :
                wsprintf(OutputString,
                         "DDE Server terminated");
            break;

    case 9 :   /* if RECEIVE, RECEIVE KEYED, RECEIVE DATA, OR  */
    case 10 :  /* RECEIVE DATA KEYED */
    case 13 :
    case 14 :
    case 23 :
    case 24 :
            MoveSenderInfo();     /* move sender info to separate vars */
            wsprintf(OutputString,   /* format the returned variables */
                     "Return Code = %i\nMessage Length = %lu\nJob Name = %s\nUser Name = %s\nJob Number = %s\nUser Profile = %s\nFrom Key = %s",
                     DQ_RC,
                     *lplRecLength,
                     lpJobName,
                     lpUserName,
                     lpJobNum,
                     lpUserProfile,
                     lpRecKey_Name);
            break;


    case 15 :   /* if QUERY DATA QUEUE */
            wsprintf(OutputString,
                     "Return Code = %i\nMaximum Length = %lu\nSequence = %i\nForce = %i\nSendId = %i\nDescription = %s\nKey Length = %i",
                     DQ_RC,
                     MaxLength,
                     Sequence,
                     Force,
                     SendId,
                     (LPSTR)Description,
                     KeyLength);
            break;

    case 17 :     /* if GET MESSAGE */
            wsprintf(OutputString,
                     "Return Code = %i\nMessage Length = %i\nMessage = %s",
                     DQ_RC,
                     MsgLength,
                     MsgData);
            break;
  }
      /* display the results in a message box */
  MessageBox(hWnd1, OutputString, "Results...", MB_OK);
  cleanup_buf();
}




/*========================================================================
 Execute_Batch : this routine retrieves an input filename and an ouput
                 file name, reads the input file, recalls the variations
                 and runs them storing the results in the output file
=========================================================================*/
void Execute_Batch(void)
{
BOOL CONTINUE = TRUE;         /* a continue flag */
BOOL SKIP = FALSE;            /* a flag for skipping variations */
int  cmd_code;                /* the command code */
char tc;                      /* the current charcter */
char testid[17];                   /* the test id */
char command[12];                 /* the test command */
HCURSOR hCursor, hOldCursor;      /* cursor handles */

   /* change cursor from arrow to hourglass */
hCursor = LoadCursor(NULL, IDC_WAIT);
hOldCursor = SetCursor(hCursor);
ShowCursor(1);

  /* if the input file was correctly read into input buffer */
if (Read_Input_File())
  {
         /* then create the output file...if that is successful */
    if (Create_Output_File())
      do       /* then start loop reading in id, command etc. */
      {  get_id(testid,&tc);                 /* get test id */
         get_cmd(command);                   /* get test command */
         cmd_code = parse_cmd(command);      /* assign command code */
         if ((!SKIP) || (cmd_code == 23))    /* if not skipped or turning */
         {  get_comment();               /* the skip of then get comment */
            if ((cmd_code > 0) && (cmd_code < 19) )  /* if an API command */
            {  get_parms(cmd_code);          /* then get the parameters */
               out_header(testid,command);  /* output time, testid and cmd */
               Run_Command(cmd_code);    /* run the command */
               out_parms(cmd_code);      /* write out the results to file */

            }
            else                /* else if not an API command */
              switch (cmd_code)
              {
/* blank */     case 19 : out_text("\r\n"); break;
/* stop test */ case 20 : CONTINUE = FALSE; break;
/* reset */     case 21 : InFilePos = InFileBuf; tc = EOLN; break;
/* skip on */   case 22 : SKIP = TRUE ; break;
/* skip off */  case 23 : SKIP = FALSE; break;
/* pause or */  case 24 :
/* wait */      case 25 :
                          MessageBox(hWnd1,
                                     "You've reached a PAUSE in batch file",
                                     "Pause", MB_OK);
                          break;
/* invalid */   case 0  : wsprintf(outputdata,"Invalid command detected : %s",
/* command */                      (LPSTR) command);
                          MessageBox(hWnd1, outputdata,
                                     NULL, MB_OK|MB_ICONHAND);
                          break;
              }
         }
         while ((tc != EOF) && (tc != EOLN))  /*read to end of the line */
           tc = Get_Char();
      } while ((tc != EOF) && (CONTINUE));  /* while not done with file */
   }                                        /* or continue flag is set */
ShowCursor(0);
hOldCursor = SetCursor(hOldCursor);    /* change cursor back to arrow */
}



/*========================================================================
 Create_Output_File : Creates output file and dumps the time in it
=========================================================================*/
int Create_Output_File(void)
{  /* if open fails display error message */
  if ((Outfp = OpenFile(Output_File, &OutOfStruct, OF_CREATE | OF_WRITE)) == -1)
     {
      MessageBox(hWnd1, "File processing error.",
                 "OPEN", MB_OK|MB_ICONHAND);
      return 0;
    }
  else   /* if file created ok, dump the date into file */
    {  cur_time = time(&cur_time);
       w = ctime(&cur_time);
       z = localtime(&cur_time);
       strftime(w,80,"%d %B %Y",z);
       wsprintf(lpfiledata,"\r\n%s\r\n",(LPSTR)w);
       _lwrite(Outfp,lpfiledata,lstrlen(lpfiledata));
 /* attempt to close the file */
       if ( _lclose(Outfp) == -1)
         {
           MessageBox(hWnd1,"File processing error.",
                      "CLOSE", MB_OK|MB_ICONHAND);
           return 0;
         }
    }
  return 1;
}


/*========================================================================
 out_header : this dumps the variation id, command, comment and time
              into output file
=========================================================================*/
void out_header(char varid[], char command[])
{
  cur_time = time(&cur_time);
  w = ctime(&cur_time);
  z = localtime(&cur_time);
  strftime(w,80,"%I:%M:%S %p",z);   /* format time of execution */
             /* format the variation header */
wsprintf(lpfiledata,
         "Test ID : %-16s * Command : %-11s * Time : %s\r\nComment : %s\r\n",
         (LPSTR)varid,(LPSTR)command,(LPSTR)w,(LPSTR) comment);
out_text(lpfiledata);   /* write header to file */
}


/*========================================================================
 out_text : this dumps the output data into output file, open&closes too
=========================================================================*/
void out_text(LPSTR lpoutdata)
{
  if ((Outfp = OpenFile((LPSTR) NULL,
                        &OutOfStruct,
                        OF_REOPEN | OF_WRITE)) == -1)
    {  MessageBox(hWnd1, "File processing error.",
                  "OPEN", MB_OK|MB_ICONHAND);
    }
  else
   {
      _llseek(Outfp,0L, 2);     /* goto end  of file */
      _lwrite(Outfp, lpoutdata, lstrlen(lpoutdata));  /* dump output */

      if ( _lclose(Outfp) == -1)       /* close file */
        {
          MessageBox(hWnd1, "File processing error.",
                     "CLOSE", MB_OK|MB_ICONHAND);
        }
   }
}

/*========================================================================
 out_parms : this writes the results of the command out to the output file
=========================================================================*/
void out_parms(int code)
{
  switch (code)
  {
   case  17 :    /* if a GET MESSAGE */
               msgd[MsgLength] = NULL;
               wsprintf(lpfiledata,
                        "RC = %i * MsgLen = %i * MsgTxt = %s *\r\n"
                        ,DQ_RC, MsgLength, MsgData);
               out_text(lpfiledata);
               break;

   case  15 :   /* if a QUERY DATA QUEUE */

               wsprintf(lpfiledata,
                        "RC = %i * MaxLen = %lu * Seq = %i * Force = %i * Sendid = %i * KeyLen = %i * KeyTxt = %s * \r\n",
                        DQ_RC, MaxLength, Sequence, Force, SendId, KeyLength, (LPSTR)Description);
              out_text(lpfiledata);
               break;

   case  9 :
   case 10 :    /* if a RECEIVE, RECEIVE KEYED, RECEIVE DATA, */
   case 13 :    /* or a RECEIVE DATA KEYED */
   case 14 :
              wsprintf(lpfiledata,
                       "RC = %i * RecLen = %lu * Sender = %s * FrmKey = %s * \r\n",
                       DQ_RC, &RecLength, (LPSTR)SenderInfo, (LPSTR)RecKey_Name);
              out_text(lpfiledata);
              if ((Outfp = OpenFile((LPSTR) NULL, &OutOfStruct,
                                    OF_REOPEN | OF_WRITE)) == -1)
                {  MessageBox(hWnd1, "File processing error.",
                              "REOPEN", MB_OK|MB_ICONHAND);
                }
              else
               {
                  _llseek(Outfp,0L, 2);
                  _lwrite(Outfp,(LPSTR) Buf,(WORD) RecLength);

                  if ( _lclose(Outfp) == -1)
                    { MessageBox(hWnd1, "File processing error.",
                                 "CLOSE", MB_OK|MB_ICONHAND);
                    }
                  wsprintf(lpfiledata,"*\r\n");
                  out_text(lpfiledata);
               }
               break;

   default :    /* for all the rest just output the return code */
               wsprintf(lpfiledata, "RC = %i \r\n"  ,DQ_RC);
               out_text(lpfiledata);
               break;
  }
}


/*========================================================================
 alloc_bufs : allocates our sets of buffers at Window create time.
=========================================================================*/
void alloc_bufs()
{
  /* Allocate the message data buffers */
  hBuf1 = GlobalAlloc(GMEM_MOVEABLE, buf_size);
  hBuf2 = GlobalAlloc(GMEM_MOVEABLE, buf_size);
  hBuf3 = GlobalAlloc(GMEM_MOVEABLE, buf_size);
  hBuf4 = GlobalAlloc(GMEM_MOVEABLE, buf_size);
  hBuf5 = GlobalAlloc(GMEM_MOVEABLE, buf_size);

  /* Save the actual size of the buffers */
  buf_size1 = GlobalSize(hBuf1);
  buf_size2 = GlobalSize(hBuf2);
  buf_size3 = GlobalSize(hBuf3);
  buf_size4 = GlobalSize(hBuf4);
  buf_size5 = GlobalSize(hBuf5);

  /* Clear the allocated buffer and then Unlock it */
  Buf = (char far *)GlobalLock(hBuf5);
  flush_buf();
  GlobalUnlock(hBuf5);

  /* Clear the allocated buffer and then Unlock it */
  Buf = (char far *)GlobalLock(hBuf4);
  flush_buf();
  GlobalUnlock(hBuf4);

  /* Clear the allocated buffer and then Unlock it */
  Buf = (char far *)GlobalLock(hBuf3);
  flush_buf();
  GlobalUnlock(hBuf3);

  /* Clear the allocated buffer and then Unlock it */
  Buf = (char far *)GlobalLock(hBuf2);
  flush_buf();
  GlobalUnlock(hBuf2);

  /* Clear the allocated buffer */
  Buf = (char far *)GlobalLock(hBuf1);
  flush_buf();

  /* Set our global variable so that the currently active set of */
  /* buffers is 1                                                */
  wCurrentBuf = 1;

  /* Set our global buffer size variable to the size of buffer 1 */
  buf_size = buf_size1;

  /* Set our global Sender ID buffer, Key buffer and length buffers */
  /* to buffers 1.                                                  */
  lpachSenderInfo = (char far *)&SenderInfo1;
  lpszRecKey_Name = (char far *)&RecKey_Name1;
  lplRecLength    = (long far *)&RecLength1;

}


/*========================================================================
 switch_buf : Make next set of buffer the active set
=========================================================================*/
void switch_buf()
{

 switch (wCurrentBuf)
 {
  case 1:
    GlobalUnlock(hBuf1);
    break;
  case 2:
    GlobalUnlock(hBuf2);
    break;
  case 3:
    GlobalUnlock(hBuf3);
    break;
  case 4:
    GlobalUnlock(hBuf4);
    break;
  case 5:
    GlobalUnlock(hBuf5);
    break;
 }

 /* Increment the active buffer indicator to the next buffer */
 wCurrentBuf = wCurrentBuf + 1;

 /* if the indicator is greater than the max, start over at the */
 /* first set of buffers.                                       */
 if (wCurrentBuf > MAX_BUFFERS)
 {
  wCurrentBuf = 1;
 }

 switch (wCurrentBuf)
 {

  case 1:
   Buf = (char far *)GlobalLock(hBuf1);
   buf_size = buf_size1;
   lpachSenderInfo = (char far *)&SenderInfo1;
   lpszRecKey_Name = (char far *)&RecKey_Name1;
   lplRecLength    = (long far *)&RecLength1;
   break;

  case 2:
   Buf = (char far *)GlobalLock(hBuf2);
   buf_size = buf_size2;
   lpachSenderInfo = (char far *)&SenderInfo2;
   lpszRecKey_Name = (char far *)&RecKey_Name2;
   lplRecLength    = (long far *)&RecLength2;
   break;

  case 3:
   Buf = (char far *)GlobalLock(hBuf3);
   buf_size = buf_size3;
   lpachSenderInfo = (char far *)&SenderInfo3;
   lpszRecKey_Name = (char far *)&RecKey_Name3;
   lplRecLength    = (long far *)&RecLength3;
   break;

  case 4:
   Buf = (char far *)GlobalLock(hBuf4);
   buf_size = buf_size4;
   lpachSenderInfo = (char far *)&SenderInfo4;
   lpszRecKey_Name = (char far *)&RecKey_Name4;
   lplRecLength    = (long far *)&RecLength4;
   break;

  case 5:
   Buf = (char far *)GlobalLock(hBuf5);
   buf_size = buf_size5;
   lpachSenderInfo = (char far *)&SenderInfo5;
   lpszRecKey_Name = (char far *)&RecKey_Name5;
   lplRecLength    = (long far *)&RecLength5;
   break;

 }
}

/*========================================================================
  cleanup_buf : Clear the sender ID, key and length buffers after displaying
=========================================================================*/
void cleanup_buf(void)
{
switch(wType)
  {
    case 9 :   /* if RECEIVE, RECEIVE KEYED, RECEIVE DATA, OR  */
    case 10 :  /* RECEIVE DATA KEYED */
    case 13 :
    case 14 :
    case 23 :
    case 24 :
    //    if (*lplRecLength != 0)
   //     {
         _fmemset((LPSTR)lpachSenderInfo, ' ', 36);
         _fmemset((LPSTR)lpszRecKey_Name, ' ', 300);
         *lplRecLength = 0L;
   //     }
       break;

    default :
       return;
  }
}


