/*********************************************************************/
/* COPYRIGHT = 5738-PC1 (C) COPYRIGHT IBM CORP 1984, 1992            */
/*   LICENSED MATERIAL - PROGRAM PROPERTY OF IBM                     */
/*   REFER TO COPYRIGHT INSTRUCTIONS FORM NUMBER G120-2083.          */
/*********************************************************************/

//  RETURN CODES
//  ------------
#define EHNDQ_SUCCESS       0x0000  /* No error                     */
#define EHNDQ_COMMERROR     0x0001  /* Communication error          */
#define EHNDQ_EXCEPTERROR   0x0002  /* Exception error on AS/400    */
#define EHNDQ_PCERROR       0x0003  /* Personal Computer error      */

//  CONSTANTS
//  ---------
#define EHNDQ_LIFO          0x0000  /* Last in First out            */
#define EHNDQ_FIFO          0x0001  /* First in First out           */
#define EHNDQ_KEYED         0x0002  /* Keyed queue is to be created */
#define EHNDQ_FALSE         0x0000  /* False or No                  */
#define EHNDQ_TRUE          0x0001  /* True or Yes                  */
#define EHNDQ_ALL           0x0000  /* All authority                */
#define EHNDQ_EXCLUDE       0x0001  /* Exclude authority            */
#define EHNDQ_CHANGE        0x0002  /* Change authority             */
#define EHNDQ_USE           0x0003  /* Use authority                */
#define EHNDQ_LIBCRTAUT     0x0004  /* Library create authority     */

// SET MODE values
// ---------------
#define EHNDQ_YES_XLAT      0x0009  /* Set translation on           */
#define EHNDQ_NO_XLAT       0x0008  /* Set translation off          */
#define EHNDQ_YES_PEEK      0x0006  /* Set peek on                  */
#define EHNDQ_NO_PEEK       0x0002  /* Set peek off                 */
#define EHNDQ_XLAT_PEEK     0x0005  /* Set translation and peek on  */
#define EHNDQ_XLATN_PEEKY   0x0004  /* Set translation off and      */
                                    /* peek on                      */
#define EHNDQ_XLATY_PEEKN   0x0001  /* Set translation on and       */
                                    /* peek off                     */
#define EHNDQ_NO_XLAT_PEEK  0x0000  /* Set translation and peek off */


#define extentry pascal far
#define INT int
#define CHAR char
extern int extentry EHNDQ_Put(HWND  hWnd,
                              LPSTR lpszQueueName,
                              LPSTR lpszQueueLocation,
                              LPSTR lpachDataBuffer,
                              LONG  lDataLength);

extern int extentry EHNDQ_Send(HWND  hWnd,
                               LPSTR lpszQueueName,
                               LPSTR lpszQueueLocation,
                               LPSTR lpachDataBuffer,
                               LONG  lDataLength);

extern int extentry EHNDQ_PutKeyed(HWND       hWnd,
                                   LPSTR      lpszQueueName,
                                   LPSTR      lpszQueueLocation,
                                   LPSTR      lpachDataBuffer,
                                   LONG       lDataLength,
                                   LPSTR      lpszKey);

extern int extentry EHNDQ_SendKeyed(HWND       hWnd,
                                    LPSTR      lpszQueueName,
                                    LPSTR      lpszQueueLocation,
                                    LPSTR      lpachDataBuffer,
                                    LONG       lDataLength,
                                    LPSTR      lpszKey);

extern int extentry EHNDQ_Create(HWND       hWnd,
                                 LPSTR      lpszQueueName,
                                 LPSTR      lpszQueueLocation,
                                 LONG       lMaxLength,
                                 INT        nSequence,
                                 INT        nForce,
                                 INT        nAuthority,
                                 INT        nSenderID,
                                 LPSTR      lpszText);

extern int extentry EHNDQ_CreateKeyed(HWND       hWnd,
                                      LPSTR      lpszQueueName,
                                      LPSTR      lpszQueueLocation,
                                      LONG       lMaxLength,
                                      INT        nForce,
                                      INT        nAuthority,
                                      INT        nSenderID,
                                      LPSTR      lpszText,
                                      INT        nKeyLen);

extern int extentry EHNDQ_Stop(HWND  hWnd,
                               LPSTR lpszQueueLocation);

extern int extentry EHNDQ_Clear(HWND  hWnd,
                                LPSTR lpszQueueName,
                                LPSTR lpszQueueLocation);

extern int extentry EHNDQ_Delete(HWND  hWnd,
                                 LPSTR lpszQueueName,
                                 LPSTR lpszQueueLocation);

extern int extentry EHNDQ_SetMode(HWND  hWnd,
                                  LPSTR lpszQueueLocation,
                                  LONG  lMode);

extern int extentry EHNDQ_GetMessage(HWND     hWnd,
                                     LPSTR    lpszQueueLocation,
                                     LPSTR    lpszMsgBuffer,
                                     INT FAR *lpnMsgLength);

extern int extentry EHNDQ_Query(HWND      hWnd,
                               LPSTR     lpszQueueName,
                               LPSTR     lpszQueueLocation,
                               LONG FAR *lplMaxLength,
                               INT  FAR *lpnSequence,
                               INT  FAR *lpnForce,
                               INT  FAR *lpnSenderID,
                               LPSTR     lpszText,
                               INT  FAR *lpnKeyLen);

extern int extentry EHNDQ_ReceiveData(HWND      hWnd,
                                      LPSTR     lpszQueueName,
                                      LPSTR     lpszQueueLocation);

extern int extentry EHNDQ_ReceiveDataKeyed(HWND      hWnd,
                                           LPSTR     lpszQueueName,
                                           LPSTR     lpszQueueLocation,
                                           LPSTR     lpszKey);

extern int extentry EHNDQ_CancelRequest(HWND      hWnd,
                                        LPSTR     lpszQueueName,
                                        LPSTR     lpszQueueLocation);

extern int extentry EHNDQ_CancelRequestKeyed(HWND      hWnd,
                                             LPSTR     lpszQueueName,
                                             LPSTR     lpszQueueLocation,
                                             LPSTR     lpszKey);

extern int extentry EHNDQ_Receive(HWND      hWnd,
                                  LPSTR     lpszQueueName,
                                  LPSTR     lpszQueueLocation,
                                  LONG      lWaitTime,
                                  INT       nSenderID,
                                  LPSTR     lpachDataBuffer,
                                  LONG FAR *lplLengthRecord,
                                  LPSTR     lpachSenderIDInfo);

extern int extentry EHNDQ_ReceiveRequest(HWND      hWnd,
                                         LPSTR     lpszQueueName,
                                         LPSTR     lpszQueueLocation,
                                         LONG      lWaitTime,
                                         INT       nSenderID,
                                         LPSTR     lpachDataBuffer,
                                         LONG FAR *lplLengthRecord,
                                         LPSTR     lpachSenderIDInfo);

extern int extentry EHNDQ_ReceiveKeyed(HWND      hWnd,
                                       LPSTR     lpszQueueName,
                                       LPSTR     lpszQueueLocation,
                                       LONG      lWaitTime,
                                       LPSTR     lpszKey,
                                       LPSTR     lpachSearchOrder,
                                       INT       nSenderID,
                                       LPSTR     lpachDataBuffer,
                                       LONG FAR *lplLengthRecord,
                                       LPSTR     lpszKeyOutput,
                                       LPSTR     lpachSenderIDInfo);

extern int extentry EHNDQ_ReceiveRequestKeyed(HWND      hWnd,
                                              LPSTR     lpszQueueName,
                                              LPSTR     lpszQueueLocation,
                                              LONG      lWaitTime,
                                              LPSTR     lpszKey,
                                              LPSTR     lpachSearchOrder,
                                              INT       nSenderID,
                                              LPSTR     lpachDataBuffer,
                                              LONG FAR *lplLengthRecord,
                                              LPSTR     lpszKeyOutput,
                                              LPSTR     lpachSenderIDInfo);

extern int extentry EHNDQ_GetCapability(HWND      hWnd,
                                        INT  FAR *lpnFunctionalLevel);

